'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbprocedurelibrary.exe
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
%UseWebBrowser  = 1
#Include Once "win32api.inc"
#Include "scictrl.inc"
#Include "htmlhelp.inc"
#Include "mshtml.inc"

#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "icons\gbprocedurelibrary.ico"
#Resource Icon xfont "icons\font.ico"
#Resource Icon xhelp "icons\help.ico"
#Resource Icon xindent, "icons\indent.ico"
#Resource Icon xoutdent, "icons\outdent.ico"
#Resource Icon xcomment, "icons\comment.ico"
#Resource Icon xuncomment, "icons\uncomment.ico"
#Resource Icon xredo, "icons\redo.ico"
#Resource Icon xundo, "icons\undo.ico"
#Resource Icon xfoldall, "icons\fold.ico"
#Resource Icon xunfoldall, "icons\unfold.ico"
#Resource Icon xxprint, "icons\print.ico"
#Resource Icon xsettings, "icons\settings.ico"
#Resource Icon xcopy, "icons\copy.ico"
#Resource Icon xlsearcha, "icons\little_searcha.ico"
#Resource Icon xlsearchb, "icons\little_searchb.ico"
#Resource Icon xsplit, "icons\split.ico"
#Resource Icon xdual, "icons\dual.ico"
#Resource Icon xpbwin, "icons\pbwin.ico"
#Resource Icon xlist, "icons\list.ico"
#Resource Icon xblank, "icons\blank.ico"
#Resource Icon xstop, "icons\stop.ico"
#Resource Icon xfolder, "icons\folder.ico"
#Resource Icon xsortdown "icons\sortdescending.ico"
#Resource Icon xsortup "icons\sortascending.ico"
#Resource Icon xtop "icons\top.ico"
#Resource Icon xmid "icons\mid.ico"
#Resource Icon xbottom "icons\bottom.ico"
#Resource Icon xsingle "icons\single.ico"

Declare Function CryptGetHashParamX Lib "AdvAPI32.dll" Alias "CryptGetHashParam" _
      (ByVal hHash As Dword, ByVal dwParam As Dword, ByVal pbData As Byte Ptr, _
      pdwDataLen As Dword, ByVal dwFlags As Dword) As Long

Declare Function PATHMATCHSPEC Lib "SHLWAPI.DLL" Alias "PathMatchSpecA" ( pszFile As AsciiZ, pszSpec As AsciiZ ) As Long

$Ver            = "1.17"
$DLimit         = "++" + "--" + ";;"
$TempSourceCode = "tempfiles\temp_compiler.bas"
$MEFile         = "tempfiles\temp_me.bas"
$RightViewFile  = "tempfiles\rightview.txt"
$FakeFile       = "tempfiles\fakefile.bas"

Type CustomColors
    c(15) As Long
End Type

Type LocalCodeType
    fname As WStringZ * %Max_Path       'procedure name
    fparent As WStringZ * %Max_Path     'file in which the code is found
    type As WStringZ * 21               'Sub/Function/Macro/Class/...
    date As WStringZ * 11               'last edit date
    startline As Long                   '1st line of procedure in $LocalCode
    stopline As Long                    'Last line of procedure in $LocalCode
    startpos As Long                    '1st char/byte of procedure in $LocalCode
    stoppos As Long                     'Last char/byte of procedure in $LocalCode
    lines As Long                       'Total lines
    chars As Long                       'Total char
    bookmark As Long                    'used in bookmark
    parentline As Long                  'line of procedure in parent file
    lcpos As Long                       'matches sequnce in library - only used in LCS() search results
    md5 As String * 32                  'MD5
End Type

Enum Equates Singular
    IDC_ListViewS = 500
    IDC_ListView
    IDC_Toolbar
    IDC_Sci
    IDC_SciV
    IDC_StatusBar
    IDC_LabelHA
    IDC_LabelVA
    IDC_SearchLabel 'snippet search label
    IDC_BtnFind     'search snippets command
    IDC_BtnFindL    'search only the procedure names
    IDC_ComboBox    'snippet search term
    IDC_WaitLabel
    IDC_WebBrowser

    IDT_Build
    IDT_Stop
    IDT_Redo
    IDT_Undo
    IDT_Indent
    IDT_Outdent
    IDT_Comment
    IDT_UnComment
    IDT_FoldAll
    IDT_UnFoldAll
    IDT_Copy
    IDT_Print
    IDT_Font
    IDT_Library
    IDT_Folder
    IDT_SingleView
    IDT_SplitScreen
    IDT_DualView
    IDT_Settings
    IDT_OpenInIDE
    IDT_Help

    IDM_Test

    IDM_OpenFile
    IDM_SaveAsFile

    IDM_EditCut
    IDM_EditCopy
    IDM_EditPaste
    IDM_EditDelete
    IDM_EditClear
    IDM_EditCopyAll

    IDM_ListViewDelete
    IDM_ListViewClear
    IDM_SelectIDE
    IDM_OpenParentFileInLeftViewLV
    IDM_OpenParentFileInLeftViewLVS
    IDM_OpenParentFileInIDE
    IDM_OpenParentFolder
    IDM_UseAsRightView
    IDM_ShowUnique
    IDM_BookmarkLV
    IDM_BookmarkLVS
    IDM_ShowBookmarks
    IDM_ClearBookmarks
    IDM_ClearBookmarkLV
    IDM_ClearBookmarkLVS
    IDM_BuildSingleFile
    IDM_SetFileExt
    IDM_SetHelpPB
    IDM_ViewProcedureLibrary
    IDM_SetTextEditor
    IDM_ShowDupes

    IDM_SciCut
    IDM_SciCopy
    IDM_SciPaste
    IDM_SciDelete
    IDM_SciClear
    IDM_SciCopyAll
    IDM_SciUndo
    IDM_SciRedo
    IDM_SciComment
    IDM_SciUnComment
    IDM_SciIndent
    IDM_SciOutDent
    IDM_SciFoldAll
    IDM_SciUnFoldAll
    IDM_SciRemoveBlanks
    IDM_SciLeftJustify
    IDM_SciFormat
    IDM_SciOpenInIDE
    IDM_SciOpenInHelpPB
    IDM_GoTo

    IDM_SyntaxHighlighting
    IDM_URLRecognition
    IDM_LineNumbers
    IDM_GreenBars
    IDM_BraceHighlighting
    IDM_IndentationGuides
    IDM_AutoIndent
    IDM_CallTips
    IDM_PersistentCallTips
    IDM_AutoCompletion
    IDM_CodeFolding
    IDM_ColorKeywords
    IDM_ColorComments
    IDM_ColorStrings
    IDM_ColorNumbers
    IDM_ColorOperators
    IDM_AutoCopy

    IDM_CodeUpper
    IDM_CodeLower
    IDM_CodeMixed
    IDM_CodeAsTyped

    IDM_IndentSize
    IDM_ManageBlankLines
    IDM_MaxBlanks
    IDM_PreBlanks
    IDM_Tab2Space

    IDM_Sep
    IDM_Copy
    IDM_SetGoodChar
    IDM_CaseSensitive
    IDM_Unimportant
    IDM_LocalHelp
    IDM_EmailAuthor

    IDM_GetSub
    IDM_GetFunction
    IDM_GetClass
    IDM_GetEnum
    IDM_GetType
    IDM_GetThread
    IDM_GetFastProc
    IDM_GetCallback
    IDM_GetDeclare

    IDM_GetMacro
    IDM_GetUnion
    IDM_GetProperty
    IDM_GetMethod
    IDM_GetInterface

    IDM_SelectAllTypes
    IDM_UnSelectAllTypes

    'Lexer
    Style_Numbers   = 1
    Style_Strings   = 2
    Style_Keywords  = 3
    Style_Comments  = 4
    Style_Operators = 6
    Style_Light     = 10
    Style_Dark      = 11
    Style_URL       = 12
    Style_HotSpot   = 13

End Enum

Global hDlg, hSci, hSciV, hToolbar, ghHook, hLib, hComboBox, hComboEdit As Dword
Global hListView, hListViewS, hBtnFind, hBtnFindL, hContextComboEdit    As Dword
Global hHeader, hHeaderS, hContextLV, hBuild, hPBWin, hThread, hWait    As Dword
Global hImageListLV, hContextLVS, hHelp, hColors,hSyntax                As Dword
Global hFontLV, hFontSci, hFontToolbar, hSettings, hContextSci          As Dword
Global hProcedures, hCodeCase, hFormat, hDebug                          As Dword
Global LibraryFileName, FontName, FontNameSci, SearchTerm, GoodChar     As WStringZ * %Max_Path
Global FontSize, FontAttr, CaseSensitive, LastSelection,Unimportant     As Long
Global OldSciProc, SortDirection, NoMD5, Debug, IndexDirty              As Long
Global SplitHAinWork, SplitVAinWork, OldTextProc, SortInWork            As Long
Global VABarTop,HABarLeft, LinesPerPage, BuildInWork, ShowDupes         As Long

Global FileCount, FolderCount, LineCount, TotalFileCount                As Long
Global Files(), Folders()                                               As DirData
Global PathIDE, FileExt, StartFolder, LVZ, ViewMode,SingleFile          As WStringZ * %Max_Path
Global LC(), LCS()                                                      As LocalCodeType
Global GulpA, Gulp(), RightView, CallTipText, fileBuf                   As String

Global GetSub, GetFunction, GetClass, GetEnum, GetType                As Long
Global GetCallback, GetThread, GetDeclare, GetFastProc                As Long
Global GetMacro, GetUnion, GetProperty, GetMethod, GetInterface       As Long
'Global Syntax Highlighting
Global LWords(), UWords(), MWords()                                   As String
Global ColorComments, ColorKeywords, ColorNumbers, ColorOperators     As Long
Global ColorStrings                                                   As Long

Global SyntaxHighlighting, LineNumbers, IndentationGuides, AutoIndent As Long
Global BraceHighlighting, GreenBars, URLRecognition, CallTips         As Long
Global CodeFolding, CodeCase, AutoCompletion, PersistentCallTips      As Long
Global AutoCopy                                                       As Long

Global SyntaxInWork, ShowLibrary                                      As Long
Global Tab2SpacesNumber, IndentSize                                   As Long
Global FindStructure                                                  As Sci_TextToFind
Global CustomColorList                                                As CustomColors

'Global Variables: Intellisense
Global ListSeparator As Long
Global Ref_MemTerm1() As String,  Ref_MemMember1() As String
Global Ref_MemTerm2() As String,  Ref_MemMember2() As String
Global Ref_Term1() As String, Ref_Desc1() As String, Ref_Syntax1() As String
Global Ref_Term2() As String, Ref_Desc2() As String, Ref_Syntax2() As String
Global Ref_Term3() As String, Ref_Desc3() As String, Ref_Syntax3() As String
Global PathHelpPB, PathTextEditor, ExternalFileName                As WStringZ * %Max_Path
Global qStart, qStop, qFreq                                        As Quad

'Encryption
Global hProv As Dword, strHash As String * 16, strHashPtr As Byte Ptr

'Code Formatter
Global ManageBlankLines, procB, MaxB As Long

Function PBMain() As Long
    'md5 initialization
    If GetCSPHandle(hProv) < 2 Then
       If hProv Then CryptReleaseContext hProv, 0
       NoMD5 = 1
    End If
    strHashPtr = VarPtr(strHash)
    'dialog
    Dialog New Pixels, 0, "gbProcedureLibrary   v" + $ver,300,300,200,200, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
    Dialog Set Icon hDlg, "logo"
    DragAcceptFiles hDlg, %True
    CreateSplitterControls
    CreateToolbar
    CreateLeftControls
    CreateScintilla
    CreateStatusBar
    CreateButtonTooltips
    Dialog Show Modal hDlg Call DlgProc
    If hProv = 0 Then CryptReleaseContext hProv, 0
End Function

CallBack Function DlgProc() As Long
    Local temp$, iReturn, i, iPos As Long, pt As PointAPI, rc As Rect
    Local nmtb As TBNotify Ptr, PTT As TooltipText Ptr
    Local hScintilla As Dword, pLVDI As LV_DispInfoW Ptr
    Local iLine, iLevel, iExpanded As Long
    Local pNSC As SCNotification Ptr, CharAtLeft As String
    Local URL As WStringZ * %Max_Path
    Local LVData As NM_ListView
    Local iRow, iCol As Long, pNMLV As NMListView Ptr

    Select Case Cb.Msg
         Case %WM_InitDialog
             ReDim Folders(0), Files(0), LC(0), LCS(0)
             QueryPerformanceFrequency qFreq
             settings_ini "get"
             manageviewfiles "get"
             Control Set Text hDlg, %IDC_ComboBox, SearchTerm
             If IsFalse(IsFolder (Exe.Path$ + "tempfiles")) Then MkDir Exe.Path$ + "tempfiles"
             If IsFile(Command$) Then LibraryFileName = LCase$(Command$)
             BuildAcceleratorTable
             CreateContextMenus
             SetFixedControlFonts
             SetControlFonts
             InitKeywords
             InitSciControl hSci  : SetCodeStyle hSci
             InitSciControl hSciV : SetCodeStyle hSciV
             LoadSampleCode hSci
             'load results listview
             LoadIndexS
             ListView_SetItemCountEx(hListViewS, UBound(LCS), %LVSICF_noInvalidateAll) 'max rows
             ListView Select hDlg, %IDC_ListViewS, 1
             ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
             'load main index
             LoadIndex
             ListView_SetItemCountEx(hListView, UBound(LC), %LVSICF_noInvalidateAll) 'max rows
             ListView Select hDlg, %IDC_ListView, LastSelection
             ListView_SetItemState hListView, LastSelection-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
             Sci_SetText hSci, GetSpecifiedProcedure(LastSelection)
             Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, "Folder: " + RTrim$(StartFolder,"\")
             ManageScreenContent
             SetMenusAndToolbar

       Case %WM_Destroy
             If IndexDirty Then 'save index
                  If IsFile(LibraryFileIndex) Then Kill LibraryFileIndex
                  Open LibraryFileIndex For Binary As #1 : Put #1,, LC() : Close #1
             End If
             If IsFile(LibraryFileIndexS) Then Kill LibraryFileIndexS
             Open LibraryFileIndexS For Binary As #1 : Put #1,, LCS() : Close #1  'have to save each session

             ManageViewFiles "save"
             ListView Get Select hDlg, %IDC_ListView To LastSelection
             SetWindowLong hSci, %GWL_WNDPROC, OldSciProc   'un-subclass
             settings_ini "save"

         Case %WM_Size
             ResizeWindow

         Case %WM_DROPFILES
             temp$ = GetDroppedFileName(Cb.WParam)
             DragFinish Cb.WParam
             If IsFile(temp$) Then
                  LibraryFileName = LCase$(temp$)
                  OpenProcedureFile
             End If

         Case %WM_ContextMenu
             pt.x = Lo(Integer,Cb.LParam) : pt.y = Hi(Integer, Cb.LParam)
             Select Case Cb.WParam
                  Case hListViewS
                      TrackPopupMenu hContextLVS, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0
                  Case hListView
                      TrackPopupMenu hContextLV, %TPM_LeftAlign, pt.x, pt.y, 0, Cb.Hndl, ByVal 0
             End Select

         Case %WM_SetCursor
             iReturn = GetDlgCtrliD(Cb.WParam)
             If (iReturn = %IDC_LabelHA) Or SplitHAInWork Then
                      MousePtr 9 : Function = 1    '9 = horizontal cursor
                      Select Case Hi(Word, Cb.LParam)
                           Case %WM_LButtonDown : SplitHAInWork = 1 : MoveHABarLeftRight
                           Case %WM_MouseMove   : If SplitHAInWork Then MoveHABarLeftRight
                           Case %WM_LButtonUp
                               SplitHAInWork = 0 : MoveHABarLeftRight : ResizeWindow
                               Control Set Color hDlg, %IDC_LabelHA, %Black, %Blue
                               Control ReDraw hDlg, %IDC_LabelHA
                               Control ReDraw hDlg, %IDC_ListView
                      End Select
             ElseIf (iReturn = %IDC_LabelVA) Or SplitVAInWork Then
                      MousePtr 7 : Function = 1    '9 = horizontal cursor
                      Select Case Hi(Word, Cb.LParam)
                           Case %WM_LButtonDown : SplitVAInWork = 1 : MoveVABarUpDown
                           Case %WM_MouseMove   : If SplitVAInWork Then MoveVABarUpDown
                           Case %WM_LButtonUp
                               SplitVAInWork = 0 : MoveVABarUpDown : ResizeWindow
                               Control Set Color hDlg, %IDC_LabelVA, %Black, %Red
                               Control ReDraw hDlg, %IDC_LabelVA
                               Control ReDraw hDlg, %IDC_ListView
                      End Select
             End If


         Case %WM_Command
             Select Case Cb.Ctl

                   Case %IdOk    'pressing Enter in ComboBox edit box
                         If Cb.CtlMsg = %BN_Clicked Then
                              Select Case GetParent(GetFocus)
                                 Case hComboBox
                                       SearchList
                                       AddSearchTermToComboBox
                              End Select
                              Function = 1
                         End If

                  Case %IDC_BtnFind   : SearchSnippets : AddSearchTermToComboBox      'contents of functions
                  Case %IDC_BtnFindL  : SearchList     : AddSearchTermToComboBox         'function names only

                  Case %IDT_Redo      : Sci_Redo hSci
                  Case %IDT_Undo      : Sci_Undo hSci
                  Case %IDT_Comment   : Sci_BlockComment hSci
                  Case %IDT_UnComment : Sci_BlockUnComment hSci
                  Case %IDT_Indent    : Sci_TAB hSci
                  Case %IDT_Outdent   : Sci_BackTAB hSci
                  Case %IDT_FoldAll   : SciFoldAll hSci
                  Case %IDT_UnFoldAll : SciUnFoldAll hSci

                  Case %IDT_Library
                      ShowLibrary Xor= 1
                      SetMenusAndToolbar
                      ResizeWindow

                  Case %IDT_SplitScreen
                      ViewMode = "SplitScreen"
                      ManageScreenContent
                      SetMenusAndToolbar
                      ResizeWindow

                  Case %IDT_DualView
                      ViewMode = "DualView"
                      ManageScreenContent
                      SetMenusAndToolbar
                      ResizeWindow

                  Case %IDT_SingleView
                      ViewMode = "SingleView"
                      ManageScreenContent
                      SetMenusAndToolbar
                      ResizeWindow

                  Case %IDT_Stop
                      BuildInWork = 0
                      If BuildInWork Then DisplayWaitDialog

                  Case %IDT_Folder
                      SetStartFolder

                  Case %IDT_Build
                      If ShowLibrary = 0 Then ShowLibrary = 1 : ResizeWindow : SetMenusAndToolbar
                      Thread Create BuildLocalLibrary(0) To hThread
                      Thread Close hThread To hThread

                  Case %IDT_OpenInIDE
                      If GetFocus <> hSci And GetFocus <> hSciV Then
                           SciOpenInIDE hSci
                      Else
                           SciOpenInIDE GetFocus
                      End If
                  Case %IDT_Copy
                      Clipboard Reset
                      temp$ = Sci_GetSelText(hSci)
                      If Len(temp$) = 0 Then temp$ = Sci_GetText(hSci)
                      Clipboard Set Text temp$
                  Case %IDT_Print     : PrintContent hSci
                  Case %IDT_Font      : SelectMainFont
                  Case %IDT_Settings  : ShowSummaryReport

                  Case %IDT_Help
                      temp$ = "http://www.garybeene.com/sw/gbprocedurelibrary.htm"
                      iReturn = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

                  'Toolbar Help dropdown =========================================================
                  Case %IDM_LocalHelp
                      temp$ = Exe.Path$ + "localhelp\gbprocedurelibrary.htm"
                      iReturn = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

                  Case %IDM_EmailAuthor
                      iReturn = ShellExecute(hDlg, "Open", "mailto:gbeene@airmail.net?subject=gbProcedureLibrary", $Nul, $Nul, %SW_ShowNormal)


                  'Toolbar Settings dropdown =========================================================
                  Case %IDM_SyntaxHighlighting
                      SyntaxHighlighting Xor=1
                      SetMenusAndToolbar
                      If SyntaxHighlighting Then LexAll(hSci) Else StyleAllDefault(hSci)

                  Case %IDM_LineNumbers
                      LineNumbers Xor=1
                      SetMenusAndToolbar
                      ShowMargins hSci

                  Case %IDM_IndentationGuides
                      IndentationGuides Xor=1
                      SetMenusAndToolbar
                      SendMessage hSci, %Sci_SetIndentationGuides, IIf(IndentationGuides, %SC_IV_LookBoth,%SC_IV_None), 0
                      SendMessage hSciV, %Sci_SetIndentationGuides, IIf(IndentationGuides, %SC_IV_LookBoth,%SC_IV_None), 0

                  Case %IDM_AutoIndent
                      AutoIndent Xor=1
                      SetMenusAndToolbar

                  Case %IDM_BraceHighlighting
                      BraceHighlighting Xor=1
                      SetMenusAndToolbar

                  Case %IDM_GreenBars
                      GreenBars Xor=1
                      SetMenusAndToolbar
                      If GreenBars Then CreateGreenBars(1,hSci) Else CreateGreenBars(0,hSci)
                      If GreenBars Then CreateGreenBars(1,hSciV) Else CreateGreenBars(0,hSciV)

                  Case %IDM_URLRecognition
                      URLRecognition Xor=1
                      SetMenusAndToolbar
                      LexAll hSci

                  Case %IDM_CallTips
                      CallTips Xor=1
                      SetMenusAndToolbar

                  Case %IDM_PersistentCallTips
                      PersistentCallTips Xor=1
                      SetMenusAndToolbar

                  Case %IDM_AutoCompletion
                      AutoCompletion Xor=1
                      SetMenusAndToolbar

                  Case %IDM_CodeFolding
                      CodeFolding Xor=1
                      SetMenusAndToolbar
                      ShowMargins hSci
                      If CodeFolding Then SetFoldLevels(hSci)

                  Case %IDM_AutoCopy
                      AutoCopy Xor=1
                      SetMenusAndToolbar

                  Case %IDM_ColorKeywords
                      ColorKeyWords = SelectColor (ColorKeyWords)
                      SendMessage hSci, %SCI_StyleSetFore, %Style_Keywords,  ColorKeywords
                      SendMessage hSciV, %SCI_StyleSetFore, %Style_Keywords,  ColorKeywords
                   Case %IDM_ColorComments
                        ColorComments = SelectColor (ColorComments)
                        SendMessage hSci, %SCI_StyleSetFore, %Style_Comments,  ColorComments
                        SendMessage hSciV, %SCI_StyleSetFore, %Style_Comments,  ColorComments
                   Case %IDM_ColorStrings
                        ColorStrings = SelectColor (ColorStrings)
                        SendMessage hSci, %SCI_StyleSetFore, %Style_Strings, ColorStrings
                        SendMessage hSciV, %SCI_StyleSetFore, %Style_Strings, ColorStrings
                   Case %IDM_ColorNumbers
                        ColorNumbers = SelectColor (ColorNumbers)
                        SendMessage hSci, %SCI_StyleSetFore, %Style_Numbers, ColorNumbers
                        SendMessage hSciV, %SCI_StyleSetFore, %Style_Numbers, ColorNumbers
                   Case %IDM_ColorOperators
                        ColorOperators = SelectColor (ColorOperators)
                        SendMessage hSci, %SCI_StyleSetFore, %Style_Operators, ColorOperators
                        SendMessage hSciV, %SCI_StyleSetFore, %Style_Operators, ColorOperators

                   Case %IDM_CodeAsTyped
                        CodeCase = 0
                        SetCodeStyle(hSci)  : LexAll(hSci)
                        SetCodeStyle(hSciV) : LexAll(hSciV)
                        SetMenusAndToolbar
                   Case %IDM_CodeMixed
                        CodeCase = 1
                        SetCodeStyle(hSci)  : LexAll(hSci)
                        SetCodeStyle(hSciV) : LexAll(hSciV)
                        SetMenusAndToolbar

                   Case %IDM_CodeLower
                        CodeCase = 2
                        SetCodeStyle(hSci)  : LexAll(hSci)
                        SetCodeStyle(hSciV) : LexAll(hSciV)
                        SetMenusAndToolbar

                   Case %IDM_CodeUpper
                        CodeCase = 3
                        SetCodeStyle(hSci)  : LexAll(hSci)
                        SetCodeStyle(hSciV) : LexAll(hSciV)
                        SetMenusAndToolbar

                   Case %IDM_IndentSize       : SetIndentSize
                   Case %IDM_MaxBlanks        : SetMaxBlanks
                   Case %IDM_PreBlanks        : SetPreBlanks
                   Case %IDM_Tab2Space        : SetTab2Space

                   Case %IDM_ManageBlankLines
                        ManageBlankLines Xor= 1
                        SetMenusAndToolbar

                  'PB Toolbar Button  ========================================================
                  Case %IDM_SelectIDE      : SelectIDE
                   Case %IDM_SetHelpPB      : SelectHelpPB

                  'Build Toolbar Button  ========================================================

                   Case %IDM_ShowDupes
                        ShowDupes Xor=1
                        SetMenusAndToolbar
                        Control ReDraw hDlg, %IDC_ListView
                   Case %IDM_CaseSensitive
                        CaseSensitive Xor=1
                        SetMenusAndToolbar
                   Case %IDM_Unimportant
                        Unimportant Xor=1
                        SetMenusAndToolbar

                   Case %IDM_GetSub
                        GetSub Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetFunction
                        GetFunction Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetCallback
                        GetCallback Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetThread
                        GetThread Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetFastProc
                        GetFastProc Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetClass
                        GetClass Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetEnum
                        GetEnum Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetType
                        GetType Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetDeclare
                        GetDeclare Xor=1
                        SetMenusAndToolbar

                   Case %IDM_GetMacro
                        GetMacro Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetUnion
                        GetUnion Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetProperty
                        GetProperty Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetMethod
                        GetMethod Xor=1
                        SetMenusAndToolbar
                   Case %IDM_GetInterface
                        GetInterface Xor=1
                        SetMenusAndToolbar

                   Case %IDM_SelectAllTypes   : SelectAllTypes(1) : SetMenusAndToolbar
                   Case %IDM_UnSelectAllTypes : SelectAllTypes(0) : SetMenusAndToolbar

                   Case %IDM_BuildSingleFile
                      If ShowLibrary = 0 Then ShowLibrary = 1 : ResizeWindow : SetMenusAndToolbar
                      Thread Create BuildLocalLibrary(1) To hThread   '1 means select a single file
                      Thread Close hThread To hThread

                   Case %IDM_SetFileExt      : SetFileExt
                   Case %IDM_SetTextEditor   : SelectTextEditor

                   Case %IDM_ViewProcedureLibrary
                      iReturn = Shell("Notepad " + LibraryFileName, 1)

                  'Orphans =====================================================================
                  Case %IDM_SetGoodChar
                      temp$ = GoodChar
                      SetGoodCharacters
                      If temp$ <> GoodChar Then OpenProcedureFile

                  Case %IDM_Test
                      Debug = 1
                      ManageDebug

                  'ComboEdit Context =====================================================================
                  Case %IDM_EditCut     : SendMessage GetFocus, %WM_CUT, 0, 0
                  Case %IDM_EditCopy    : SendMessage GetFocus, %WM_COPY, 0, 0
                  Case %IDM_EditPaste   : SendMessage hComboEdit, %WM_PASTE, 0, 0
                  Case %IDM_EditDelete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
                  Case %IDM_EditClear   : SendMessage GetFocus, %WM_CLEAR, 0, 0
                  Case %IDM_EditCopyAll
                      Control Get Text hDlg, hComboBox To temp$
                      Clipboard Reset : Clipboard Set Text temp$


                  'hSci Context ====================================================================
                  Case %IDM_SciCut              : Sci_Cut GetFocus
                  Case %IDM_SciCopy             : Sci_Copy GetFocus
                  Case %IDM_SciPaste            : Sci_Paste GetFocus
                  Case %IDM_SciDelete           : Sci_Clear GetFocus
                  Case %IDM_SciClear            : Sci_SetText GetFocus,""
                  Case %IDM_SciCopyAll
                      Clipboard Reset
                      Clipboard Set Text Sci_GetText(GetFocus)

                  Case %IDM_SciUndo             : Sci_Undo GetFocus
                  Case %IDM_SciRedo             : Sci_Redo GetFocus
                  Case %IDM_SciComment          : Sci_BlockComment GetFocus
                  Case %IDM_SciUnComment        : Sci_BlockUnComment GetFocus
                  Case %IDM_SciIndent           : Sci_TAB GetFocus
                  Case %IDM_SciOutdent          : Sci_BackTAB GetFocus
                  Case %IDM_SciFoldAll          : SciFoldAll GetFocus
                  Case %IDM_SciUnFoldAll        : SciUnFoldAll GetFocus
                  Case %IDM_SciRemoveBlanks     : SciRemoveBlanks GetFocus
                  Case %IDM_SciLeftJustify      : SciLeftJustify GetFocus
                  Case %IDM_SciFormat           : SciFormat GetFocus
                  Case %IDM_OpenFile            : OpenExternalFile
                  Case %IDM_SaveAsFile          : SaveAsFile
                  Case %IDM_SciOpenInHelpPB     : SciOpenInHelpPB GetFocus
                  Case %IDM_SciOpenInIDE        : SciOpenInIDE GetFocus

                  'ListView Context ====================================================================
                  Case %IDM_UseAsRightView
                      RightView = Sci_GetText(hSci)
                      If ViewMode = "DualView" Then Sci_SetText(hSciV,RightView)

                  Case %IDM_BookmarkLV
                      IndexDirty = 1
                      ListView Get Select hDlg, %IDC_ListView To i
                      LC(i).bookmark = 1

                  Case %IDM_BookmarkLVS
                      IndexDirty = 1
                      ListView Get Select hDlg, %IDC_ListViewS To i
                      LC(LCS(i).lcPos).bookmark = 1

                  Case %IDM_ClearBookmarkLV
                      IndexDirty = 1
                      ListView Get Select hDlg, %IDC_ListView To i
                      LC(i).bookmark = 0

                  Case %IDM_ClearBookmarkLVS
                      IndexDirty = 1
                      ListView Get Select hDlg, %IDC_ListViewS To i
                      LC(LCS(i).lcPos).bookmark = 0

                  Case %IDM_ClearBookmarks
                      IndexDirty = 1
                      For i = 1 To UBound(LC)
                           LC(i).bookmark = 0
                      Next i

                  Case %IDM_ShowBookmarks       : ShowBookmarks
                  Case %IDM_ShowUnique          : ShowUnique

                  Case %IDM_ListViewDelete
                      ListView Get Select hDlg, %IDC_ListViewS To i
                      Array Delete LCS(i)
                      ReDim Preserve LCS(UBound(LCS)-1)
                      ListView_SetItemCountEx(hListViewS, UBound(LCS), %LVSICF_noInvalidateAll) 'max rows
                      ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

                  Case %IDM_ListViewClear
                      ReDim LCS(0)
                      ListView_SetItemCountEx(hListViewS, 0, %LVSICF_noInvalidateAll) 'max rows
                      ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

                  Case %IDM_OpenParentFileInLeftViewLVS : OpenParentFileInLeftView %IDC_ListViewS
                  Case %IDM_OpenParentFileInLeftViewLV  : OpenParentFileInLeftView %IDC_ListView

                  Case %IDM_OpenParentFileInIDE
                      ListView Get Select hDlg, %IDC_ListView To i
                      ListView Get Text hDlg, %IDC_ListView, i, 6 To temp$
                      If IsFile(temp$) Then
                           'i = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                           i = Shell(PathIDE + " " + temp$, 1)
                      Else
                           Beep
                      End If

                  Case %IDM_OpenParentFolder
                      ListView Get Select hDlg, %IDC_ListView To i
                      ListView Get Text hDlg, %IDC_ListView, i, 6 To temp$
                      i = ShellExecute(hDlg, "Open", PathName$(Path,temp$), $Nul, $Nul, %SW_ShowNormal)




             End Select

         Case %WM_Notify
             Select Case Cb.NmId
                  Case %IDT_Build To %IDT_Help
                      Select Case Cb.NmCode
                           Case %TTN_GetDispInfo
                               PTT = Cb.LParam
                               Select Case Cb.NmId
                                    Case %IDT_Build         : @PTT.@lpszText = "Build Procedure Library (Separate Thread)"
                                    Case %IDT_Stop          : @PTT.@lpszText = "Cancel Library Build"
                                    Case %IDT_Folder        : @PTT.@lpszText = "Select the Start Folder" + $CrLf + "..." + Right$(StartFolder,30)
                                    Case %IDT_Redo          : @PTT.@lpszText = "Reverse the Last Undo Action"
                                    Case %IDT_Undo          : @PTT.@lpszText = "Reverse the Last Edit Action"
                                    Case %IDT_Comment       : @PTT.@lpszText = "Format Selection as a Code Comment"
                                    Case %IDT_UnComment     : @PTT.@lpszText = "Remove Comment Formatting"
                                    Case %IDT_Indent        : @PTT.@lpszText = "Indent Selected Lines (Move Right on Line)"
                                    Case %IDT_OutDent       : @PTT.@lpszText = "Un-Indent Selected Lines (Move Left on Line)"
                                    Case %IDT_FoldAll       : @PTT.@lpszText = "Fold All Procedures"
                                    Case %IDT_UnFoldAll     : @PTT.@lpszText = "Remove Folding from All Procedures"
                                    Case %IDT_Copy          : @PTT.@lpszText = "Copy Main Editor Selection to Clipboard"
                                    Case %IDT_Print         : @PTT.@lpszText = "Print Main Editor Selection"
                                    Case %IDT_Font          : @PTT.@lpszText = "Select Main Font"
                                    Case %IDT_Settings      : @PTT.@lpszText = "Display Status Report"
                                    Case %IDT_SingleView    : @PTT.@lpszText = "Single Editor Displayed"
                                    Case %IDT_SplitScreen   : @PTT.@lpszText = "Split Screen (Same Procedure Both Views)"
                                    Case %IDT_DualView      : @PTT.@lpszText = "Dual View (Different Procedure Each View"
                                    Case %IDT_Library       : @PTT.@lpszText = "Display Procedure Library"
                                    Case %IDT_OpenInIDE     : @PTT.@lpszText = "Open in PB IDE"
                                    Case %IDT_Help          : @PTT.@lpszText = "Open Online Help Page"
                               End Select
                      End Select

                  Case %IDC_ListView
                      Select Case Cb.NmCode
                           Case %LVN_ColumnClick
                               If UBound(LC) < 1 Then Beep : Exit Function
                               SortInWork = 1
                               Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                               SortDirection = SortDirection Xor 1
                               MousePtr 11
                               'Sort
                               If SortDirection = 0 Then
                                  If LVData.iSubItem = 0 Then Array Sort LC(1), Call SortByFNameA
                                    If LVData.iSubItem = 1 Then Array Sort LC(1), Call SortByDateA
                                    If LVData.iSubItem = 2 Then Array Sort LC(1), Call SortByFSpecA
                                    If LVData.iSubItem = 3 Then Array Sort LC(1), Call SortByLinesA
                                    If LVData.iSubItem = 4 Then Array Sort LC(1), Call SortByTypeA
                                    If LVData.iSubItem = 5 Then Array Sort LC(1), Call SortByFSpecA
                                    If LVData.iSubItem = 6 Then Array Sort LC(1), Call SortByStartLineA
                                    If LVData.iSubItem = 7 Then Array Sort LC(1), Call SortByStartPosA
                                    If LVData.iSubItem = 8 Then Array Sort LC(1), Call SortByParentLineA
                                    If LVData.iSubItem = 9 Then Array Sort LC(1), Call SortByCRCA
                               Else
                                    If LVData.iSubItem = 0 Then Array Sort LC(1), Call SortByFNameD
                                    If LVData.iSubItem = 1 Then Array Sort LC(1), Call SortByDateD
                                    If LVData.iSubItem = 2 Then Array Sort LC(1), Call SortByFSpecD
                                    If LVData.iSubItem = 3 Then Array Sort LC(1), Call SortByLinesD
                                    If LVData.iSubItem = 4 Then Array Sort LC(1), Call SortByTypeD
                                    If LVData.iSubItem = 5 Then Array Sort LC(1), Call SortByFSpecD
                                    If LVData.iSubItem = 6 Then Array Sort LC(1), Call SortByStartLineD
                                    If LVData.iSubItem = 7 Then Array Sort LC(1), Call SortByStartPosD
                                    If LVData.iSubItem = 8 Then Array Sort LC(1), Call SortByParentLineD
                                    If LVData.iSubItem = 9 Then Array Sort LC(1), Call SortByCRCD
                               End If
                               SetHeaderIcons LVData.iSubItem, hHeader
                               SortInWork = 0
                               'Select the top line following the sort
                               ListView Select hDlg, %IDC_ListView, 1
                               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                               Sci_SetText hSci, GetSpecifiedProcedure(1)
                               SendMessage(hSci, %Sci_SetFirstVisibleLine,0,0)
                               Control ReDraw hDlg, %IDC_ListView
                               Control Set Focus hDlg, %IDC_ListView
                               MousePtr 1
                           Case %LVN_ItemChanged
                                  pNMLV = Cb.LParam
                                  If (@pNMLV.uChanged And  %LVIF_STATE) = %LVIF_STATE Then
                                       If ((@pNMLV.uNewState Xor  @pNMLV.uOldState) And %LVIS_SELECTED) Then
                                           If (@pNMLV.uNewState And %LVIS_SELECTED) Then
                                                iRow = @pNMLV.iItem + 1
                                                temp$ = GetSpecifiedProcedure(iRow)
                                                Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, LC(iRow).fParent
                                                Sci_SetText hSci, temp$
                                                If AutoCopy Then
                                                    Clipboard Reset
                                                    Clipboard Set Text temp$
                                                End If
                                           End If
                                       End If
                                  End If
                           Case %LVN_GetDispInfo
                               pLVDI = Cb.LParam               'pointer to LVDISPINFO structure for requested subitem
                               iRow = @pLVDI.item.iItem + 1    'row being asked for
                               iCol = @pLVDI.item.iSubItem
                               Select Case iCol
                                    Case 0 : @pLVDI.item.pszText = VarPtr(LC(iRow).fname)
                                    Case 1 : @pLVDI.item.pszText = VarPtr(LC(iRow).date)
                                    Case 2
                                        LVZ = PathName$(Namex, LC(iRow).fParent)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 3
                                        LVZ = Str$(LC(iRow).lines)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 4 : @pLVDI.item.pszText = VarPtr(LC(iRow).type)
                                    Case 5 : @pLVDI.item.pszText = VarPtr(LC(iRow).fparent)
                                    Case 6
                                        LVZ = Str$(LC(iRow).startline) + " - " + Str$(LC(iRow).stopline)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 7
                                        LVZ = Str$(LC(iRow).startpos) + " - " + Str$(LC(iRow).stoppos)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 8
                                        LVZ = Str$(LC(iRow).parentline+1)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 9
                                        LVZ = LC(iRow).md5
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                               End Select
                               If ShowDupes Then
                                    Select Case iRow
                                        Case UBound(LC)
                                             If LC(iRow).md5 = LC(iRow-1).md5 Then @pLVDI.item.iImage = 4
                                        Case Else
                                             If LC(iRow).md5 = LC(iRow-1).md5 And LC(iRow).md5 = LC(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 3
                                             ElseIf LC(iRow).md5 <> LC(iRow-1).md5 And LC(iRow).md5 = LC(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 2
                                             ElseIf LC(iRow).md5 = LC(iRow-1).md5 And LC(iRow).md5 <> LC(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 4
                                             End If
                                    End Select
                               End If
                        End Select

                  Case %IDC_ListViewS
                      Select Case Cb.NmCode
                           Case %LVN_ColumnClick
                               If UBound(LCS) < 1 Then Beep : Exit Function
                               SortInWork = 1
                               Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                               SortDirection = SortDirection Xor 1
                               MousePtr 11
                               'Sort
                               If SortDirection = 0 Then
                                    If LVData.iSubItem = 0 Then Array Sort LCS(1), Call SortByFNameA
                                    If LVData.iSubItem = 1 Then Array Sort LCS(1), Call SortByDateA
                                    If LVData.iSubItem = 2 Then Array Sort LCS(1), Call SortByFSpecA
                                    If LVData.iSubItem = 3 Then Array Sort LCS(1), Call SortByLinesA
                                    If LVData.iSubItem = 4 Then Array Sort LCS(1), Call SortByTypeA
                                    If LVData.iSubItem = 5 Then Array Sort LCS(1), Call SortByFSpecA
                                    If LVData.iSubItem = 6 Then Array Sort LCS(1), Call SortByStartLineA
                                    If LVData.iSubItem = 7 Then Array Sort LCS(1), Call SortByStartPosA
                                    If LVData.iSubItem = 8 Then Array Sort LCS(1), Call SortByParentLineA
                                    If LVData.iSubItem = 9 Then Array Sort LCS(1), Call SortByCRCA
                               Else
                                    If LVData.iSubItem = 0 Then Array Sort LCS(1), Call SortByFNameD
                                    If LVData.iSubItem = 1 Then Array Sort LCS(1), Call SortByDateD
                                    If LVData.iSubItem = 2 Then Array Sort LCS(1), Call SortByFSpecD
                                    If LVData.iSubItem = 3 Then Array Sort LCS(1), Call SortByLinesD
                                    If LVData.iSubItem = 4 Then Array Sort LCS(1), Call SortByTypeD
                                    If LVData.iSubItem = 5 Then Array Sort LCS(1), Call SortByFSpecD
                                    If LVData.iSubItem = 6 Then Array Sort LCS(1), Call SortByStartLineD
                                    If LVData.iSubItem = 7 Then Array Sort LCS(1), Call SortByStartPosD
                                    If LVData.iSubItem = 8 Then Array Sort LCS(1), Call SortByParentLineD
                                    If LVData.iSubItem = 9 Then Array Sort LC(1), Call SortByCRCD
                               End If
                               SetHeaderIcons LVData.iSubItem, hHeaderS
                               SortInWork = 0
                               'Select the top line following the sort
                               ListView Select hDlg, %IDC_ListViewS, 1
                               ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                               Sci_SetText hSci, GetSpecifiedProcedure(LCS(1).lcPos)
                               SendMessage(hSci, %Sci_SetFirstVisibleLine,0,0)
                               Control ReDraw hDlg, %IDC_ListViewS
                               Control Set Focus hDlg, %IDC_ListViewS
                               MousePtr 1

                           Case %LVN_ItemChanged
                                  pNMLV = Cb.LParam
                                  If (@pNMLV.uChanged And  %LVIF_STATE) = %LVIF_STATE Then
                                       If ((@pNMLV.uNewState Xor  @pNMLV.uOldState) And %LVIS_SELECTED) Then
                                           If (@pNMLV.uNewState And %LVIS_SELECTED) Then
                                                iRow = @pNMLV.iItem + 1
'                                Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, LC(iRow).fParent
                                                'Sci_SetText hSci, GetSelectedProcedure(LCS(iRow).lcPos)  '<-- no need. happens when next two lines are executed
                                                ListView Select hDlg, %IDC_ListView, LCS(iRow).lcPos
                                                ListView Visible hDlg, %IDC_ListView, LCS(iRow).lcPos
                                           End If
                                       End If
                                  End If

                           Case %LVN_GetDispInfo
                               pLVDI = Cb.LParam               'pointer to LVDISPINFO structure for requested subitem
                               iRow = @pLVDI.item.iItem + 1    'row being asked for
                               iCol = @pLVDI.item.iSubItem
                               Select Case iCol
                                    Case 0 : @pLVDI.item.pszText = VarPtr(LCS(iRow).fname)
                                    Case 1 : @pLVDI.item.pszText = VarPtr(LCS(iRow).date)
                                    Case 2
                                        LVZ = PathName$(Namex, LCS(iRow).fParent)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 3
                                        LVZ = Str$(LCS(iRow).lines)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 4 : @pLVDI.item.pszText = VarPtr(LCS(iRow).type)
                                    Case 5 : @pLVDI.item.pszText = VarPtr(LCS(iRow).fparent)
                                    Case 6
                                        LVZ = Str$(LCS(iRow).startline) + " - " + Str$(LCS(iRow).stopline)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 7
                                        LVZ = Str$(LCS(iRow).startpos) + " - " + Str$(LCS(iRow).stoppos)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 8
                                        LVZ = Str$(LCS(iRow).parentline+1)
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                                    Case 9
                                        LVZ = LCS(iRow).md5
                                        @pLVDI.item.pszText = VarPtr(LVZ)
                               End Select
                               If ShowDupes Then
                                    Select Case iRow
                                        Case UBound(LCS)
                                             If LCS(iRow).md5 = LCS(iRow-1).md5 Then @pLVDI.item.iImage = 4
                                        Case Else
                                             If LCS(iRow).md5 = LCS(iRow-1).md5 And LCS(iRow).md5 = LCS(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 3
                                             ElseIf LCS(iRow).md5 <> LCS(iRow-1).md5 And LCS(iRow).md5 = LCS(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 2
                                             ElseIf LCS(iRow).md5 = LCS(iRow-1).md5 And LCS(iRow).md5 <> LCS(iRow+1).md5 Then
                                                 @pLVDI.item.iImage = 4
                                             End If
                                    End Select
                               End If
                      End Select

                  Case %IDC_Toolbar
                      Select Case Cb.NmCode
                           Case %TBN_DROPDOWN
                               nmtb = Cb.LParam
                               Select Case @nmtb.iItem
                                    Case %IDT_Build
                                        SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                                        MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                                        TrackPopupMenu (hBuild, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                                    Case %IDT_OpenInIDE
                                        SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                                        MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                                        TrackPopupMenu (hPBWin, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                                    Case %IDT_Settings
                                        SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                                        MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                                        TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                                    Case %IDT_Help
                                        SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                                        MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                                        TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                               End Select
                      End Select

                  Case %IDC_Sci, %IDC_SciV
                      hScintilla = Cb.NmHwnd
                      pNSC = Cb.LParam
                      CharAtLeft = Chr$(@pNSC.ch)
                      iPos = SendMessage( hScintilla, %SCI_GetCurrentPos, 0, 0)  'get current position
                      Select Case @pNSC.hdr.Code
                           Case %SCN_MarginClick
                               If CodeFolding Then
                                    iLine  = SendMessage( hScintilla, %SCI_LineFromPosition, @pNSC.position, 0)
                                    iLevel = (SendMessage (hScintilla, %SCI_GetFoldLevel, iLine, 0) And %SC_FoldLevelNumberMask)
                                    iExpanded = SendMessage(hScintilla, %SCI_GetFoldExpanded, iLine, 0)
                                    If (iExpanded = 1) And (iLevel = 1) Then
                                        SendMessage hScintilla, %SCI_MarkerDelete, iLine, %SC_MarkNum_Folder
                                        SendMessage hScintilla, %SCI_MarkerDelete, iLine, %SC_MarkNum_FolderOpen
                                        SendMessage hScintilla, %SCI_ToggleFold, iLine, 0
                                    ElseIf (iExpanded = 0) And (iLevel = 1) Then
                                        SendMessage hScintilla, %SCI_MarkerDelete, iLine, %SC_MarkNum_FolderOpen
                                        SendMessage hScintilla, %SCI_MarkerDelete, iLine, %SC_MarkNum_Folder
                                        SendMessage hScintilla, %SCI_ToggleFold, iLine, 0
                                    End If
                               End If
                           Case %SCN_UpdateUI
                               'brace highlighting
                               If BraceHighlighting Then
                                    iReturn = SendMessage( hScintilla, %SCI_GetCurrentPos, 0, 0) 'get caret position
                                    Select Case SendMessage(hScintilla, %SCI_GetCharAt, iReturn, 0)
                                          Case 40,41
                                              iPos = SendMessage( hScintilla, %SCI_BraceMatch, iReturn, 0)
                                              If iPos = -1 Then
                                                 SendMessage hScintilla, %SCI_BraceBadlight, iReturn, 0
                                             Else
                                                 SendMessage hScintilla, %SCI_BraceHighlight, iReturn, iPos
                                             End If
                                          Case Else
                                              SendMessage hScintilla, %SCI_BraceBadlight, -1, 0
                                    End Select
                               End If
                           Case %SCN_StyleNeeded
                               iPos = SendMessage(hScintilla, %SCI_GetEndStyled,0,0)
                               If (SplitVAInWork = 0) And (SplitHAInWork = 0) Then CustomPBLexer iPos, @pNSC.position, hScintilla   'start,end

                           Case %SCN_HotSpotClick
                               URL = GetHotspotText(@pNSC.position,hScintilla)
                               iReturn = ShellExecute(hDlg, "Open", (URL), $Nul, $Nul, %SW_ShowNormal)

                           Case %SCN_CharAdded
                                 If InStr("(. ", CharAtLeft) Then
                                     If (CallTips <> 0) And (AutoCompletion <> 0) Then
                                          CallTipText = Intellisense(iPos, CharAtLeft, hScintilla)
                                          If Len(CallTipText) Then Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, CallTipText
                                     End If
                                 End If
                                 If AutoIndent And @pNSC.ch = 10 Then SmartIndentation(iPos,hScintilla)
                      End Select


             End Select
    End Select
End Function

Sub Settings_INI(Task$)
    Local x, y As Long, xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
    INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
    If Task$ = "get" Then
         'get dialog top/left from INI file and use to set Dialog location
         Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
         Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
         Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

         'get dialog width/height from INI file and use to set Dialog size
         GetPrivateProfileString "All", "Width", "825", xResult, %Max_Path, INIFileName
         GetPrivateProfileString "All", "Height", "450", yResult, %Max_Path, INIFileName
         Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

         'get value for string variables
         Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
         Getprivateprofilestring "All", "FontNameSci", "Courier New", FontNameSci, %Max_Path, INIFileName
         Getprivateprofilestring "All", "LibraryFileName", "tempfiles\procedure_library.txt", LibraryFileName, %Max_Path, INIFileName
         Getprivateprofilestring "All", "FileExt", "*.bas;*.inc", FileExt, %Max_Path, INIFileName
         Getprivateprofilestring "All", "SearchTerm", "subclass", SearchTerm, %Max_Path, INIFileName
         Getprivateprofilestring "All", "GoodChar", Chr$(48 To 57, 65 To 90, 97 To 122), GoodChar, %Max_Path, INIFileName
         Getprivateprofilestring "All", "PathIDE", "c:\pbwin10\bin\pbedit.exe", PathIDE, %Max_Path, INIFileName
         Getprivateprofilestring "All", "PathHelpPB", "c:\pbwin10\bin\pbwin.chm", PathHelpPB, %Max_Path, INIFileName
         Getprivateprofilestring "All", "PathTextEditor", "NotePad.exe", PathTextEditor, %Max_Path, INIFileName
         Getprivateprofilestring "All", "StartFolder", PathName$(Path,Exe.Path$), StartFolder, %Max_Path, INIFileName
         Getprivateprofilestring "All", "ViewMode", "SingleView", ViewMode, %Max_Path, INIFileName
         Getprivateprofilestring "All", "ExternalFileName", "", ExternalFileName, %Max_Path, INIFileName
         Getprivateprofilestring "All", "SingleFile", "", SingleFile, %Max_Path, INIFileName

         Getprivateprofilestring "All", "STerm0", "api", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 1, temp
         Getprivateprofilestring "All", "STerm1", "sdk", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 2, temp
         Getprivateprofilestring "All", "STerm2", "ddt", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 3, temp
         Getprivateprofilestring "All", "STerm3", "browser", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 4, temp
         Getprivateprofilestring "All", "STerm4", "rnd", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 5, temp
         Getprivateprofilestring "All", "STerm5", "subclass", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 6, temp
         Getprivateprofilestring "All", "STerm6", "timer", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 7, temp
         Getprivateprofilestring "All", "STerm7", "com", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 8, temp
         Getprivateprofilestring "All", "STerm8", "serial", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 9, temp
         Getprivateprofilestring "All", "STerm9", "ocx", temp, %Max_Path, INIFileName : ComboBox Insert hDlg, %IDC_ComboBox, 10, temp

         'get value for numeric variables
         Getprivateprofilestring "All", "SortDirection", "1", temp, %Max_Path, INIFileName:  SortDirection = Val(temp)
         Getprivateprofilestring "All", "FileCount", "0", temp, %Max_Path, INIFileName:  FileCount = Val(temp)
         Getprivateprofilestring "All", "FolderCOunt", "0", temp, %Max_Path, INIFileName:  FolderCount = Val(temp)
         Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
         Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
         Getprivateprofilestring "All", "CaseSensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
         Getprivateprofilestring "All", "Unimportant", "0", temp, %Max_Path, INIFileName:  Unimportant = Val(temp)
         Getprivateprofilestring "All", "GetSub", "1", temp, %Max_Path, INIFileName:  GetSub = Val(temp)
         Getprivateprofilestring "All", "GetFunction", "1", temp, %Max_Path, INIFileName:  GetFunction = Val(temp)
         Getprivateprofilestring "All", "GetCallback", "1", temp, %Max_Path, INIFileName:  GetCallback = Val(temp)
         Getprivateprofilestring "All", "GetThread", "1", temp, %Max_Path, INIFileName:  GetThread = Val(temp)
         Getprivateprofilestring "All", "GetFastProc", "1", temp, %Max_Path, INIFileName:  GetFastProc = Val(temp)
         Getprivateprofilestring "All", "GetClass", "1", temp, %Max_Path, INIFileName:  GetClass = Val(temp)
         Getprivateprofilestring "All", "GetEnum", "1", temp, %Max_Path, INIFileName:  GetEnum = Val(temp)
         Getprivateprofilestring "All", "GetType", "1", temp, %Max_Path, INIFileName:  GetType = Val(temp)
         Getprivateprofilestring "All", "GetDeclare", "1", temp, %Max_Path, INIFileName:  GetDeclare = Val(temp)

         Getprivateprofilestring "All", "GetMacro", "1", temp, %Max_Path, INIFileName:  GetMacro = Val(temp)
         Getprivateprofilestring "All", "GetUnion", "1", temp, %Max_Path, INIFileName:  GetUnion = Val(temp)
         Getprivateprofilestring "All", "GetProperty", "1", temp, %Max_Path, INIFileName:  GetProperty = Val(temp)
         Getprivateprofilestring "All", "GetMethod", "1", temp, %Max_Path, INIFileName:  GetMethod = Val(temp)
         Getprivateprofilestring "All", "GetInterface", "1", temp, %Max_Path, INIFileName:  GetInterface = Val(temp)

         Getprivateprofilestring "All", "ShowDupes", "0", temp, %Max_Path, INIFileName:  ShowDupes = Val(temp)
         Getprivateprofilestring "All", "VABarTop", "200", temp, %Max_Path, INIFileName:  VABarTop = Val(temp)
         Getprivateprofilestring "All", "HABarLeft", "200", temp, %Max_Path, INIFileName:  HABarLeft = Val(temp)
         Getprivateprofilestring "All", "LinesPerPage", "50", temp, %Max_Path, INIFileName:  LinesPerPage = Val(temp)
         Getprivateprofilestring "All", "ShowLibrary", "1", temp, %Max_Path, INIFileName:  ShowLibrary = Val(temp)
         Getprivateprofilestring "All", "LastSelection", "1", temp, %Max_Path, INIFileName:  LastSelection = Val(temp)

         Getprivateprofilestring "Syntax", "ColorKeywords", Str$(%rgb_MediumBlue), temp, %Max_Path, INIFileName:  ColorKeyWords = Val(temp)
         Getprivateprofilestring "Syntax", "ColorComments", Str$(%rgb_DarkGreen), temp, %Max_Path, INIFileName:  ColorComments = Val(temp)
         Getprivateprofilestring "Syntax", "ColorStrings", Str$(%Red), temp, %Max_Path, INIFileName:  ColorStrings = Val(temp)
         Getprivateprofilestring "Syntax", "ColorOperators", Str$(%rgb_Gray), temp, %Max_Path, INIFileName:  ColorOperators = Val(temp)
         Getprivateprofilestring "Syntax", "ColorNumbers", Str$(%rgb_Brown), temp, %Max_Path, INIFileName:  ColorNumbers = Val(temp)
         Getprivateprofilestring "Syntax", "CodeCase", "1", temp, %Max_Path, INIFileName:  CodeCase = Val(temp)

         Getprivateprofilestring "Syntax", "SyntaxHighlighting", "1", temp, %Max_Path, INIFileName:  SyntaxHighlighting = Val(temp)
         Getprivateprofilestring "Syntax", "LineNumbers", "1", temp, %Max_Path, INIFileName:  LineNumbers = Val(temp)
         Getprivateprofilestring "Syntax", "IndentationGuides", "1", temp, %Max_Path, INIFileName:  IndentationGuides = Val(temp)
         Getprivateprofilestring "Syntax", "AutoIndent", "1", temp, %Max_Path, INIFileName:  AutoIndent = Val(temp)
         Getprivateprofilestring "Syntax", "BraceHighlighting", "1", temp, %Max_Path, INIFileName:  BraceHighlighting = Val(temp)
         Getprivateprofilestring "Syntax", "GreenBars", "1", temp, %Max_Path, INIFileName:  GreenBars = Val(temp)
         Getprivateprofilestring "Syntax", "URLRecognition", "1", temp, %Max_Path, INIFileName:  URLRecognition = Val(temp)
         Getprivateprofilestring "Syntax", "CallTips", "1", temp, %Max_Path, INIFileName:  CallTips = Val(temp)
         Getprivateprofilestring "Syntax", "PersistentCallTips", "1", temp, %Max_Path, INIFileName:  PersistentCallTips = Val(temp)
         Getprivateprofilestring "Syntax", "AutoCompletion", "1", temp, %Max_Path, INIFileName:  AutoCompletion = Val(temp)
         Getprivateprofilestring "Syntax", "CodeFolding", "1", temp, %Max_Path, INIFileName:  CodeFolding = Val(temp)
         Getprivateprofilestring "Syntax", "AutoCopy", "0", temp, %Max_Path, INIFileName:  AutoCopy = Val(temp)

         Getprivateprofilestring "All", "procB", "2", temp, %Max_Path, INIFileName : procB = Val(temp)
         Getprivateprofilestring "All", "maxB", "1", temp, %Max_Path, INIFileName : maxB = Val(temp)
         Getprivateprofilestring "All", "ManageBlankLines", "1", temp, %Max_Path, INIFileName : ManageBlankLines = Val(temp)
         Getprivateprofilestring "Syntax", "IndentSize", "3", temp, %Max_Path, INIFileName:  IndentSize = Val(temp)
         Getprivateprofilestring "Syntax", "Tab2SpacesNumber", "8", temp, %Max_Path, INIFileName:  Tab2SpacesNumber = Val(temp)

         For x = 0 To 15
             Getprivateprofilestring "All", "CustomColorC" + Format$(x,"00"), "", temp, %Max_Path, INIFileName
             CustomColorList.c(x) = Val(temp)
         Next x

    End If

    If Task$ = "save" Then
         'save dialog size/location unless minimized or maximized
         If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
             Dialog Get Loc hDlg To x,y
             WritePrivateProfileString "All", "Left", Str$(x), INIFileName
             WritePrivateProfileString "All", "Top", Str$(y), INIFileName
             Dialog Get Size hDlg To x,y
             WritePrivateProfileString "All", "Width", Str$(x), INIFileName
             WritePrivateProfileString "All", "Height", Str$(y), INIFileName
         End If
         'save string variables
         WritePrivateProfileString "All", "FontName",FontName, INIFileName
         WritePrivateProfileString "All", "FontNameSci",FontNameSci, INIFileName
         WritePrivateProfileString "All", "LibraryFileName",LibraryFileName, INIFileName
         WritePrivateProfileString "All", "FileExt",FileExt, INIFileName
         WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName
         WritePrivateProfileString "All", "GoodChar",GoodChar, INIFileName
         WritePrivateProfileString "All", "PathIDE",PathIDE, INIFileName
         WritePrivateProfileString "All", "PathHelpPB",PathHelpPB, INIFileName
         WritePrivateProfileString "All", "PathTextEditor",PathTextEditor, INIFileName
         WritePrivateProfileString "All", "StartFolder",StartFolder, INIFileName
         WritePrivateProfileString "All", "ViewMode",ViewMode, INIFileName
         WritePrivateProfileString "All", "ExternalFileName",ExternalFileName, INIFileName
         WritePrivateProfileString "All", "SingleFile",SingleFile, INIFileName

         For x = 1 To 10
             ComboBox Get Text hDlg, %IDC_ComboBox, x To temp
             WritePrivateProfileString "All", "STerm" + Trim$(Str$(x-1)),(temp), INIFileName
         Next x

         'save numeric variables
'      WritePrivateProfileString "All", "SortDirection", (Str$(SortDirectiont)), INIFileName
         WritePrivateProfileString "All", "FileCount", (Str$(FileCount)), INIFileName
         WritePrivateProfileString "All", "FolderCount", (Str$(FolderCount)), INIFileName
         WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
         WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
         WritePrivateProfileString "All", "CaseSensitive", (Str$(CaseSensitive)), INIFileName
         WritePrivateProfileString "All", "Unimportant", (Str$(Unimportant)), INIFileName

         WritePrivateProfileString "All", "GetSub", (Str$(GetSub)), INIFileName
         WritePrivateProfileString "All", "GetFunction", (Str$(GetFunction)), INIFileName
         WritePrivateProfileString "All", "GetCallback", (Str$(GetCallback)), INIFileName
         WritePrivateProfileString "All", "GetThread", (Str$(GetThread)), INIFileName
         WritePrivateProfileString "All", "GetFastProc", (Str$(GetFastProc)), INIFileName
         WritePrivateProfileString "All", "GetClass", (Str$(GetClass)), INIFileName
         WritePrivateProfileString "All", "GetEnum", (Str$(GetEnum)), INIFileName
         WritePrivateProfileString "All", "GetType", (Str$(GetType)), INIFileName
         WritePrivateProfileString "All", "GetDeclare", (Str$(GetDeclare)), INIFileName

         WritePrivateProfileString "All", "GetMacro", (Str$(GetMacro)), INIFileName
       WritePrivateProfileString "All", "GetUnion", (Str$(GetUnion)), INIFileName
         WritePrivateProfileString "All", "GetProperty", (Str$(GetProperty)), INIFileName
         WritePrivateProfileString "All", "GetMethod", (Str$(GetMethod)), INIFileName
         WritePrivateProfileString "All", "GetInterface", (Str$(GetInterface)), INIFileName
         WritePrivateProfileString "All", "ShowDupes", (Str$(ShowDupes)), INIFileName
         WritePrivateProfileString "All", "VABarTop", (Str$(VABarTop)), INIFileName
         WritePrivateProfileString "All", "HABarLeft", (Str$(HABarLeft)), INIFileName
         WritePrivateProfileString "All", "LinesPerPage", (Str$(LinesPerPage)), INIFileName
         WritePrivateProfileString "All", "ShowLibrary", (Str$(ShowLibrary)), INIFileName
         WritePrivateProfileString "All", "LastSelection", (Str$(LastSelection)), INIFileName

         WritePrivateProfileString "Syntax", "IndentSize", Str$(IndentSize), INIFileName
         WritePrivateProfileString "Syntax", "Tab2SpacesNumber", Str$(Tab2SpacesNumber), INIFileName
         WritePrivateProfileString "Syntax", "ColorKeywords", Str$(ColorKeywords), INIFileName
         WritePrivateProfileString "Syntax", "ColorComments", Str$(ColorComments), INIFileName
         WritePrivateProfileString "Syntax", "ColorStrings", Str$(ColorStrings), INIFileName
         WritePrivateProfileString "Syntax", "ColorOperators", Str$(ColorOperators), INIFileName
         WritePrivateProfileString "Syntax", "ColorNumbers", Str$(ColorNumbers), INIFileName
         WritePrivateProfileString "Syntax", "CodeCase", Str$(CodeCase), INIFileName

         WritePrivateProfileString "Syntax", "SyntaxHighlighting", Str$(SyntaxHighlighting), INIFileName
         WritePrivateProfileString "Syntax", "LineNumbers", Str$(LineNumbers), INIFileName
         WritePrivateProfileString "Syntax", "IndentationGuides", Str$(IndentationGuides), INIFileName
         WritePrivateProfileString "Syntax", "AutoIndent", Str$(AutoIndent), INIFileName
         WritePrivateProfileString "Syntax", "BraceHighlighting", Str$(BraceHighlighting), INIFileName
         WritePrivateProfileString "Syntax", "GreenBars", Str$(GreenBars), INIFileName
         WritePrivateProfileString "Syntax", "URLRecognition", Str$(URLRecognition), INIFileName
         WritePrivateProfileString "Syntax", "CallTips", Str$(CallTips), INIFileName
         WritePrivateProfileString "Syntax", "PersistentCallTips", Str$(PersistentCallTips), INIFileName
         WritePrivateProfileString "Syntax", "AutoCompletion", Str$(AutoCompletion), INIFileName
         WritePrivateProfileString "Syntax", "CodeFolding", Str$(CodeFolding), INIFileName
         WritePrivateProfileString "Syntax", "AutoCopy", Str$(AutoCopy), INIFileName

         WritePrivateProfileString "All", "procB", (Str$(procB)), INIFileName
         WritePrivateProfileString "All", "maxB", (Str$(maxB)), INIFileName
         WritePrivateProfileString "All", "ManageBlankLines", (Str$(ManageBlankLInes)), INIFileName

         For x = 0 To 15
             temp = Str$(CustomColorList.c(x))
             WritePrivateProfileString "All", "CustomColorC" + Format$(x,"00"), temp, INIFileName
         Next x

    End If
End Sub

Sub CreateStatusBar
    Control Add Statusbar, hDlg, %IDC_StatusBar, "", 0, 0, 0, 0
    Statusbar Set Parts hDlg, %IDC_StatusBar, 150,99999
End Sub

Sub CreateToolbar
      Local hImageList As Dword

      ImageList New Icon 24,24,24,30 To hImageList
      ImageList Add Icon hImageList, "logo"        '1   'build

      ImageList Add Icon hImageList, "xundo"       '2
      ImageList Add Icon hImageList, "xredo"       '3

      ImageList Add Icon hImageList, "xcomment"    '4
      ImageList Add Icon hImageList, "xuncomment"  '5

      ImageList Add Icon hImageList, "xindent"     '6
      ImageList Add Icon hImageList, "xoutdent"    '7

      ImageList Add Icon hImageList, "xfoldall"    '8
      ImageList Add Icon hImageList, "xunfoldall"  '9

      ImageList Add Icon hImageList, "xcopy"       '10
      ImageList Add Icon hImageList, "xxprint"     '11
      ImageList Add Icon hImageList, "xfont"       '12
      ImageList Add Icon hImageList, "xsettings"   '13
      ImageList Add Icon hImageList, "xhelp"       '14
      ImageList Add Icon hImageList, "xsplit"      '15
      ImageList Add Icon hImageList, "xdual"       '16
      ImageList Add Icon hImageList, "xpbwin"      '17
      ImageList Add Icon hImageList, "xlist"       '18
      ImageList Add Icon hImageList, "xblank"      '19
      ImageList Add Icon hImageList, "xstop"       '20
      ImageList Add Icon hImageList, "xfolder"     '21
      ImageList Add Icon hImageList, "xsingle"     '22

      Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
      Control Handle hDlg, %IDC_Toolbar To hToolbar
      SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

      Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist

      Toolbar Add Button    hDlg, %IDC_Toolbar, 18,  %IDT_Library,  %BTNS_Check, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 21, %IDT_Folder,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 1, %IDT_Build,  %BTNS_Button Or %BTNS_DropDown, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 20, %IDT_Stop,  %BTNS_Button, ""

      Toolbar Add Separator hDlg, %IDC_Toolbar, 15

      Toolbar Add Button    hDlg, %IDC_Toolbar, 22,  %IDT_SingleView,  %BTNS_CheckGroup, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 15,  %IDT_SplitScreen,  %BTNS_CheckGroup, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 16,  %IDT_DualView,  %BTNS_CheckGroup, ""

      Toolbar Add Separator hDlg, %IDC_Toolbar, 15

      Toolbar Add Button    hDlg, %IDC_Toolbar, 2, %IDT_UnDo,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 3, %IDT_ReDo,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Comment,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 5,  %IDT_UnComment,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Indent,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_OutDent,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_FoldAll,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 9,  %IDT_UnFoldAll,  %BTNS_Button, ""

      Toolbar Add Separator hDlg, %IDC_Toolbar, 15

      Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Copy,  %BTNS_Button, ""
      Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Print,  %BTNS_Button, ""
      Toolbar Add Button    hDlg, %IDC_Toolbar, 17, %IDT_OpenInIDE,  %BTNS_Button Or %BTNS_DropDown, ""

      Toolbar Add Separator hDlg, %IDC_Toolbar, 15

      Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Font,  %BTNS_Button, ""
      Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, ""

      Toolbar Add Separator hDlg, %IDC_Toolbar, 15

      Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Help, %BTNS_Button Or %BTNS_DropDown, ""
End Sub


Sub ResizeWindow
    Local w,h,i, MidPoint As Long
    Dialog Get Client hDlg To w,h

    Control Set Loc hDlg, %IDC_LabelVA, 10, VABarTop
    Control Set Size hDlg, %IDC_LabelVA, HABarLeft - 20, 6

    Control Set Loc hDlg, %IDC_LabelHA, HABarLeft, 70
    Control Set Size hDlg, %IDC_LabelHA, 6,h-110

    Control Set Size hDlg, %IDC_ComboBox,  HABarLeft - 120, 100
    Control Set Loc hDlg, %IDC_BtnFind, HABarLeft - 30, 45
    Control Set Loc hDlg, %IDC_BtnFindL, HABarLeft - 60, 45

    Control Set Loc hDlg, %IDC_ListViewS, 5, 75
    Control Set Size hDlg, %IDC_ListViewS, HABarLeft - 10, VABarTop - 80

    Control Set Loc hDlg, %IDC_ListView,  5, VABarTop + 10
    Control Set Size hDlg, %IDC_ListView, HABarLeft - 10, h - VABarTop - 40

    MidPoint = IIf(ShowLibrary, HABarLeft, 0)
    If ViewMode = "SplitScreen" Or ViewMode = "DualView" Then
         i = (w-MidPoint+10)/2
         Control Set Loc hDlg, %IDC_SciV,  MidPoint + i , 45
         Control Set Size hDlg, %IDC_SciV, i-15, h - 75

         Control Set Loc hDlg, %IDC_Sci,  MidPoint + 10, 45
         Control Set Size hDlg, %IDC_Sci, i-15, h - 75
    Else
         Control Set Loc hDlg, %IDC_Sci,  MidPoint + 10, 45
         Control Set Size hDlg, %IDC_Sci, w - MidPoint - 15, h - 75
    End If
End Sub


Sub BuildAcceleratorTable
    Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
    Dim ac(3)
    ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help     : Incr c
    ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B  : ac(c).cmd   = %IDT_Build    : Incr c
    ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_ViewProcedureLibrary     : Incr c
    ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test     : Incr c
    Accel Attach hDlg, AC() To hAccelerator
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
    Local fString As WStringZ*%Max_Path, Count As Long
    fString=Space$(%Max_Path)
   Count = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
    Function = Left$(fString,Count)                        ' put Count chars into result string
End Function

Function SelectMainFont() As Long
    Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
    Style = %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations Or %CF_ScreenFonts
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
    Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
    UnhookWindowsHookEx ghHook
    If Len(fName) Then
         FontName = fName : FontSize = fPoints : FontAttr = fStyle
         SetControlFonts
         InitSciControl hSci
         InitSciControl hSciV
    End If
End Function

Function FontDialogProc(ByVal nCode As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
      Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
      Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal WParam, ByVal LParam)
      If nCode < 0 Then Exit Function
      If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
      If nCode = %HCBT_CREATEWND Then
            cw = LParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
            cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
            GetClassName WParam, szTemp, %Max_Path      ' for each window / control as it is created
            If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
      End If
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
         cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
         cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
         GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
         If UCase$(szTemp) = "BUTTON" Then @cst.x = 120  : @cst.cx = 60           'ok and cancel
         If UCase$(szTemp) = "STATIC" Then @cst.x = 400                           'prompt
         If UCase$(szTemp) = "EDIT"   Then @cst.cx = 100 : @cst.y = @cst.y - 130  'textbox
         If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
         If UCase$(szTemp) = "#32770" Then @cst.cx = 200 : @cst.cy = @cst.cy - 130                'dialog
    End If
End Function


Sub SetMenusAndToolbar
    'Control visibility
    Control Show State hDlg, %IDC_SearchLabel, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_ComboBox, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_BtnFind, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_BtnFindL, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_ListView, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_ListViewS, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_LabelVA, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_LabelHA, IIf(ShowLibrary, %SW_Show, %SW_Hide)
    Control Show State hDlg, %IDC_SciV, IIf(ViewMode <> "SingleView", %SW_Show, %SW_Hide)

    'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SingleView, IIf(ViewMode="SingleView",1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SplitScreen, IIf(ViewMode="SplitScreen",1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_DualView, IIf(ViewMode="DualView",1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Library, ShowLibrary * %TBState_Checked Or %TBState_Enabled

    'Menus
    Menu Set State hSettings, ByCmd %IDM_SyntaxHighlighting, SyntaxHighlighting * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSettings, ByCmd %IDM_AutoCopy, AutoCopy * %MFS_Checked Or %MFS_Enabled

    Menu Set State hSyntax, ByCmd %IDM_LineNumbers, LineNumbers * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_IndentationGuides, IndentationGuides * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_AutoIndent, AutoIndent * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_BraceHighlighting, BraceHighlighting * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_GreenBars, GreenBars * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_URLRecognition, URLRecognition * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_CallTips, CallTips * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_PersistentCallTips, PersistentCallTips * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_AutoCompletion, AutoCompletion * %MFS_Checked Or %MFS_Enabled
    Menu Set State hSyntax, ByCmd %IDM_CodeFolding, CodeFolding * %MFS_Checked Or %MFS_Enabled

    Menu Set State hProcedures, ByCmd %IDM_GetSub, GetSub * %MFS_Checked Or %MFS_Enabled
   Menu Set State hProcedures, ByCmd %IDM_GetFunction, GetFunction * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetCallback, GetCallback * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetThread, GetThread * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetFastProc, GetFastProc * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetClass, GetClass * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetEnum, GetEnum * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetType, GetType * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetDeclare, GetDeclare * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetMacro, GetMacro * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetUnion, GetUnion * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetProperty, GetProperty * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetMethod, GetMethod * %MFS_Checked Or %MFS_Enabled
    Menu Set State hProcedures, ByCmd %IDM_GetInterface, GetInterface * %MFS_Checked Or %MFS_Enabled

    Menu Set State hBuild, ByCmd %IDM_ShowDupes, ShowDupes * %MFS_Checked Or %MFS_Enabled
    Menu Set State hBuild, ByCmd %IDM_CaseSensitive, CaseSensitive * %MFS_Checked Or %MFS_Enabled
    Menu Set State hBuild, ByCmd %IDM_Unimportant, Unimportant * %MFS_Checked Or %MFS_Enabled

    Menu Set State hCodeCase, ByCmd %IDM_CodeAsTyped, IIf(CodeCase=0,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hCodeCase, ByCmd %IDM_CodeMixed,   IIf(CodeCase=1,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hCodeCase, ByCmd %IDM_CodeLower,   IIf(CodeCase=2,1,0) * %MFS_Checked Or %MFS_Enabled
    Menu Set State hCodeCase, ByCmd %IDM_CodeUpper,   IIf(CodeCase=3,1,0) * %MFS_Checked Or %MFS_Enabled

    Menu Set State hFormat, ByCmd %IDM_ManageBlankLines, ManageBlankLines * %MFS_Checked Or %MFS_Enabled
End Sub

Sub CreateScintilla
    hLib = LoadLibrary(Exe.Path$ + "scilexer.dll")

    Control Add "Scintilla", hDlg, %IDC_Sci, "", 300,100,100,100, %WS_Visible Or %WS_Child Or %WS_Border, %WS_Ex_ClientEdge
    Control Handle hDlg, %IDC_Sci To hSci
    OldSciProc = SetWindowLong(hSci, %GWL_WndProc, CodePtr(NewSciProc))  'subclass

    Control Add "Scintilla", hDlg, %IDC_SciV, "", 300,100,100,100, %WS_Visible Or %WS_Child Or %WS_Border, %WS_Ex_ClientEdge
    Control Handle hDlg, %IDC_SciV To hSciV
    OldSciProc = SetWindowLong(hSciV, %GWL_WndProc, CodePtr(NewSciProc))  'subclass
End Sub

Function NewSciProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local iReturn,x,y As Long
    Local CurrentLine,ColumnNumber As Long
    Select Case Msg
         Case %WM_SetCursor
             iReturn = GetDlgCtrlID(WParam)
             If (iReturn = %IDC_LabelHA) Or SplitHAInWork Then
                      Select Case Hi(Word, LParam)
                           Case %WM_MouseMove   : If SplitHAInWork Then MoveHABarLeftRight
                           Case %WM_LButtonUp
                               SplitHAInWork = 0 : MoveHABarLeftRight : ResizeWindow
                               Control Set Color hDlg, %IDC_LabelHA, %Black, %Blue
                               Control ReDraw hDlg, %IDC_LabelHA
                      End Select
             ElseIf (iReturn = %IDC_LabelVA) Or SplitVAInWork Then
                      Select Case Hi(Word, LParam)
                           Case %WM_MouseMove   : If SplitVAInWork Then MoveVABarUpDown
                           Case %WM_LButtonUp
                               SplitVAInWork = 0 : MoveVABarUpDown : ResizeWindow
                               Control Set Color hDlg, %IDC_LabelVA, %Black, %Red
                               Control ReDraw hDlg, %IDC_LabelVA
                      End Select
             End If

         Case %WM_KeyUp, %WM_LButtonUp
             CurrentLine = Sci_GetCurrentLineNumber(hWnd)+1
             ColumnNumber = Sci_GetCurrentColumnNumber(hWnd)
             Statusbar Set Text hDlg, %IDC_Statusbar, 1, 0, "  " + Format$(ColumnNumber,"###,##0") + " / " + Format$(CurrentLine,"##,###,##0")

         Case %WM_ContextMenu
             x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
             TrackPopupMenu hContextSci, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
             Function = 0 : Exit Function
    End Select
    Function = CallWindowProc(OldSciProc, hWnd, Msg, wParam, lParam)
End Function

Sub CreateLeftControls
      Local ComboInfo As ComboBoxInfo

      Control Add Label, hDlg, %IDC_SearchLabel, "Search:", 5, 45,50,20, %SS_Notify

      Control Add ComboBox, hDlg, %IDC_ComboBox, ,55, 45, 250, 150, %CBS_AutoHScroll Or %CBS_DropDown Or %WS_TabStop Or %WS_VScroll, %WS_Ex_ClientEdge Or %WS_Ex_Left
      Control Handle hDlg, %IDC_Combobox To hComboBox
      ComboInfo.cbSize = SizeOf(ComboBoxInfo)
      GetComboBoxInfo(hComboBox, ByVal VarPtr(ComboInfo))
      hComboEdit = ComboInfo.hwndItem
      OldTextProc = SetWindowLong(hComboEdit, %GWL_WndProc, CodePtr(NewTextProc))  'subclass

      Control Add ImgButton, hDlg, %IDC_BtnFindL, "xlsearcha",  320, 60, 24,24
      Control Add ImgButton, hDlg, %IDC_BtnFind,  "xlsearchb",  320, 60, 24,24
      Control Handle hDlg, %IDC_BtnFind To hBtnFind
      Control Handle hDlg, %IDC_BtnFindL To hBtnFindL

      ImageList New Icon 16,16,24,6 To hImageListLV
      ImageList Add Icon hImageListLV, "xsortup"   '1
      ImageList Add Icon hImageListLV, "xsortdown" '2
      ImageList Add Icon hImageListLV, "xtop"     '3
      ImageList Add Icon hImageListLV, "xmid"     '4
      ImageList Add Icon hImageListLV, "xbottom"  '5

      Control Add ListView, hDlg, %IDC_ListViewS, "",  5, 45, 340, 50, %WS_Child Or %LVS_Report Or %LVS_ShowSelAlways Or %WS_TabStop Or %LVS_SingleSel Or %LVS_OwnerData, %WS_Ex_ClientEdge
      Control Handle hDlg, %IDC_ListViewS To hListViewS
      ListView Set StyleXX hDlg, %IDC_ListViewS, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
      ListView Set ImageList hDlg, %IDC_ListViewS, hImageListLV, %lvsil_small

      ListView Insert Column hDlg, %IDC_ListViewS, 1, "Name", 160, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 2, "Date", 90, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 3, "File Name",150, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 4, "Lines", 80, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 5, "Type", 70, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 6, "File Spec", 200, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 7, "Library Lines Range", 160, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 8, "Library Char Range", 180, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 9, "Parent Line", 180, 0
      ListView Insert Column hDlg, %IDC_ListViewS, 10, "MD5 Hash", 300, 0
      SendMessage (hListViewS, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)
      hHeaderS = ListView_GetHeader(hListViewS)
      Header_SetImageList hHeaderS, hImagelistLV

      Control Add ListView, hDlg, %IDC_ListView, "",  5, 85, 340, 50, %WS_Child Or %LVS_Report Or %LVS_ShowSelAlways Or %WS_TabStop Or %LVS_SingleSel Or %LVS_OwnerData, %WS_Ex_ClientEdge
      Control Handle hDlg, %IDC_ListView To hListView
      ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect
      ListView Set ImageList hDlg, %IDC_ListView, hImageListLV, %lvsil_small

      ListView Insert Column hDlg, %IDC_ListView, 1, "Name", 160, 0
      ListView Insert Column hDlg, %IDC_ListView, 2, "Date", 90, 0
      ListView Insert Column hDlg, %IDC_ListView, 3, "File Name", 150, 0
      ListView Insert Column hDlg, %IDC_ListView, 4, "Lines", 80, 0
      ListView Insert Column hDlg, %IDC_ListView, 5, "Type", 70, 0
      ListView Insert Column hDlg, %IDC_ListView, 6, "File Spec", 200, 0
      ListView Insert Column hDlg, %IDC_ListView, 7, "Library Line Range", 160, 0
      ListView Insert Column hDlg, %IDC_ListView, 8, "Library Char Range", 180, 0
      ListView Insert Column hDlg, %IDC_ListView, 9, "Parent Line", 180, 0
      ListView Insert Column hDlg, %IDC_ListView, 10, "MD5 Hash", 300, 0
      SendMessage (hListView, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)
      hHeader = ListView_GetHeader(hListView)
      Header_SetImageList hHeader, hImagelistLV
End Sub

Sub CreateSplitterControls
    Control Add Label, hDlg, %IDC_LabelHA, "", 200,70,6,300, %SS_Notify, %WS_Ex_ClientEdge 'Scintillas to the right
    Control Set Color hDlg, %IDC_LabelHA, %Black, %Blue

    Control Add Label, hDlg, %IDC_LabelVA, "", 10,200,300,6, %SS_Notify, %WS_Ex_ClientEdge 'snippet is below
    Control Set Color hDlg, %IDC_LabelVA, %Black, %Red
End Sub

Sub SetGoodCharacters
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "Visible Characters", GoodChar, x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Len(temp$) Then GoodChar = temp$
End Sub

Sub SetMaxBlanks
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "Max Consecutive Blanks", Str$(maxB), x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Val(temp$) > -1 Then MaxB = Val(temp$)
End Sub

Sub SetPreBlanks
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "Pre-Procedure Blanks", Str$(procB), x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Val(temp$) > -1 Then procB = Val(temp$)
End Sub

Sub SetIndentSize
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "Indentation Spaces", Str$(IndentSize), x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Val(temp$) > 0 Then IndentSize = Val(temp$)
End Sub

Sub SetTab2Space
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "TAB Replacement Spaces", Str$(Tab2SpacesNumber), x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Val(temp$) > 0 Then Tab2SpacesNumber = Val(temp$)
End Sub

Sub MoveHABarLeftRight
    Local pt As Point, x,y,w,h As Long
    Control Get Loc hDlg, %IDC_LabelHA To x,y

    'get new HABarLeft position
   GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
    HABarLeft = pt.x-3

    'splitterbar colors - change colors when move is in work
    Control Set Color hDlg, %IDC_LabelHA, %Black, %Red

    'resize splitterbars
    Dialog Get Client hDlg To w,h
    Control Set Loc hDlg, %IDC_LabelHA, HABarLeft, y
End Sub

Sub MoveVABarUpDown
    Local pt As Point, w,h As Long
    'get new HBarLeft position
    GetCursorPos pt               'pt has xy screen coordinates
    ScreenToClient hDlg, pt       'pt now has client coordinates
    VABarTop = pt.y-3
    'splitterbar colors - change colors when move is in work
    Control Set Color hDlg, %IDC_LabelVA, %Black, %Gray
    Control ReDraw hDlg, %IDC_LabelVA
    'resize splitterbars
    Dialog Get Client hDlg To w,h
    Control Set Loc hDlg, %IDC_LabelVA, 5, VABarTop
End Sub

Sub OpenProcedureFile
End Sub

Function NewTextProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal WParam As Long, ByVal LParam As Long) As Long
    Local x,y As Long
    Select Case Msg
         Case %WM_ContextMenu
             x = Lo(Integer,LParam) : y = Hi(Integer, LParam)    'WM_ContextMenu returns xy coordinates of mouse
             TrackPopupMenu hContextComboEdit, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
             Function = 0 : Exit Function
    End Select
    Function = CallWindowProc(OldTextProc, hWnd, Msg, WParam, LParam)
End Function

Sub CreateContextMenus
      Menu New PopUp To hContextComboEdit
      Menu Add String, hContextComboEdit, "Cut",      %IDM_EditCut,  %MF_Enabled
      Menu Add String, hContextComboEdit, "Copy",     %IDM_EditCopy,  %MF_Enabled
      Menu Add String, hContextComboEdit, "Paste",    %IDM_EditPaste,  %MF_Enabled
      Menu Add String, hContextComboEdit, "Delete",   %IDM_EditDelete,  %MF_Enabled
      Menu Add String, hContextComboEdit, "-", %IDM_Sep, 0
      Menu Add String, hContextComboEdit, "Clear All",    %IDM_EditClear,  %MF_Enabled
      Menu Add String, hContextComboEdit, "Copy All", %IDM_EditCopyAll,  %MF_Enabled

      Menu New PopUp To hContextLVS
      Menu Add String, hContextLVS, "Use As Right View",  %IDM_UseAsRightView,  %MF_Enabled
      Menu Add String, hContextLVS, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLVS, "Bookmark Procedure",  %IDM_BookmarkLVS,  %MF_Enabled
      Menu Add String, hContextLVS, "Clear Bookmark",  %IDM_ClearBookmarkLVS,  %MF_Enabled
      Menu Add String, hContextLVS, "Clear All Bookmarks",  %IDM_ClearBookmarks,  %MF_Enabled
      Menu Add String, hContextLVS, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLVS, "Show Bookmarked Procedures",  %IDM_ShowBookmarks,  %MF_Enabled
      Menu Add String, hContextLVS, "Show Unique Procedures",  %IDM_ShowUnique,  %MF_Enabled
      Menu Add String, hContextLVS, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLVS, "Remove From List",  %IDM_ListViewDelete,  %MF_Enabled
      Menu Add String, hContextLVS, "Clear List",  %IDM_ListViewClear,  %MF_Enabled
      Menu Add String, hContextLVS, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLVS, "Open Parent File in Left View",  %IDM_OpenParentFileInLeftViewLVS,  %MF_Enabled
      Menu Add String, hContextLVS, "Open Parent File in IDE",  %IDM_OpenParentFileInIDE,  %MF_Enabled
      Menu Add String, hContextLVS, "Open Parent Folder",  %IDM_OpenParentFolder,  %MF_Enabled

      Menu New PopUp To hContextLV
      Menu Add String, hContextLV, "Use As Right View",  %IDM_UseAsRightView,  %MF_Enabled
      Menu Add String, hContextLV, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLV, "Bookmark Procedure",  %IDM_BookmarkLV,  %MF_Enabled
      Menu Add String, hContextLV, "Clear Bookmark",  %IDM_ClearBookmarkLV,  %MF_Enabled
      Menu Add String, hContextLV, "Clear All Bookmarks",  %IDM_ClearBookmarks,  %MF_Enabled
      Menu Add String, hContextLV, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLV, "Show Bookmarked Procedures",  %IDM_ShowBookmarks,  %MF_Enabled
      Menu Add String, hContextLV, "Show Unique Procedures",  %IDM_ShowUnique,  %MF_Enabled
      Menu Add String, hContextLV, "-",  %IDM_Sep,  %MF_Enabled
      Menu Add String, hContextLV, "Open Parent File in Left View",  %IDM_OpenParentFileInLeftViewLV,  %MF_Enabled
      Menu Add String, hContextLV, "Open Parent File in IDE",  %IDM_OpenParentFileInIDE,  %MF_Enabled
      Menu Add String, hContextLV, "Open Parent Folder",  %IDM_OpenParentFolder,  %MF_Enabled

      Menu New PopUp To hColors
      Menu Add String, hColors, "Keyword Color", %IDM_ColorKeywords, %MF_Enabled
      Menu Add String, hColors, "Comment Color", %IDM_ColorComments, %MF_Enabled
      Menu Add String, hColors, "String Color", %IDM_ColorStrings, %MF_Enabled
      Menu Add String, hColors, "Number Color", %IDM_ColorNumbers, %MF_Enabled
      Menu Add String, hColors, "Operator Color", %IDM_ColorOperators, %MF_Enabled

      Menu New PopUp To hSyntax
    Menu Add String, hSyntax, "Line Numbers", %IDM_LineNumbers, %MF_Enabled
      Menu Add String, hSyntax, "Indentation Guides", %IDM_IndentationGuides, %MF_Enabled
      Menu Add String, hSyntax, "AutoIndent", %IDM_AutoIndent, %MF_Enabled
      Menu Add String, hSyntax, "Brace Highlighting", %IDM_BraceHighlighting, %MF_Enabled
      Menu Add String, hSyntax, "Alternating Line Colors", %IDM_GreenBars, %MF_Enabled
      Menu Add String, hSyntax, "Enable Hyperlinks", %IDM_URLRecognition, %MF_Enabled
      Menu Add String, hSyntax, "Call Tips", %IDM_CallTips, %MF_Enabled
      Menu Add String, hSyntax, "Call Tip Persistence", %IDM_PersistentCallTips, %MF_Enabled
      Menu Add String, hSyntax, "AutoCompletion", %IDM_AutoCompletion, %MF_Enabled
      Menu Add String, hSyntax, "Code Folding", %IDM_CodeFolding, %MF_Enabled

      Menu New PopUp To hFormat
    Menu Add String, hFormat, "Manage Blank Lines", %IDM_ManageBlankLines, %MF_Enabled
      Menu Add String, hFormat, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hFormat, "Set Indent Spaces Count", %IDM_IndentSize, %MF_Enabled
      Menu Add String, hFormat, "Set Max Blank Lines", %IDM_MaxBlanks, %MF_Enabled
      Menu Add String, hFormat, "Set Pre-Procedure Blanks", %IDM_PreBlanks, %MF_Enabled
      Menu Add String, hFormat, "Set Tab to Spaces Count", %IDM_Tab2Space, %MF_Enabled

      Menu New PopUp To hCodeCase
      Menu Add String, hCodeCase, "Upper", %IDM_CodeUpper, %MF_Enabled
      Menu Add String, hCodeCase, "Lower", %IDM_CodeLower, %MF_Enabled
      Menu Add String, hCodeCase, "Mixed", %IDM_CodeMixed, %MF_Enabled
      Menu Add String, hCodeCase, "As Typed", %IDM_CodeAsTyped, %MF_Enabled

      Menu New PopUp To hSettings
      Menu Add String, hSettings, "Use Syntax Highlighting", %IDM_SyntaxHighlighting, %MF_Enabled
      Menu Add String, hSettings, "Auto Copy", %IDM_AutoCopy, %MF_Enabled
      Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
      Menu Add PopUp, hSettings, "Editor", hSyntax, %MF_Enabled
      Menu Add PopUp, hSettings, "Code Case", hCodeCase, %MF_Enabled
      Menu Add PopUp, hSettings, "Colors", hColors, %MF_Enabled
      Menu Add PopUp, hSettings, "Formatting", hFormat, %MF_Enabled

      Menu New PopUp To hProcedures
      Menu Add String, hProcedures, "Sub", %IDM_GetSub, %MF_Enabled
      Menu Add String, hProcedures, "Function", %IDM_GetFunction, %MF_Enabled
      Menu Add String, hProcedures, "Callback", %IDM_GetCallback, %MF_Enabled
      Menu Add String, hProcedures, "Thread", %IDM_GetThread, %MF_Enabled
      Menu Add String, hProcedures, "FastProc", %IDM_GetFastProc, %MF_Enabled
      Menu Add String, hProcedures, "Enum", %IDM_GetEnum, %MF_Enabled
      Menu Add String, hProcedures, "Type", %IDM_GetType, %MF_Enabled
      Menu Add String, hProcedures, "Macro", %IDM_GetMacro, %MF_Enabled
      Menu Add String, hProcedures, "Union", %IDM_GetUnion, %MF_Enabled
      Menu Add String, hProcedures, "Class", %IDM_GetClass, %MF_Enabled
      Menu Add String, hProcedures, "Interface", %IDM_GetInterface, %MF_Enabled
      Menu Add String, hProcedures, "Property", %IDM_GetProperty, %MF_Enabled
      Menu Add String, hProcedures, "Method", %IDM_GetMethod, %MF_Enabled
      Menu Add String, hProcedures, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hProcedures, "Select All", %IDM_SelectAllTypes, %MF_Enabled
      Menu Add String, hProcedures, "UnSelect All", %IDM_UnSelectAllTypes, %MF_Enabled

      Menu New PopUp To hBuild
      Menu Add String, hBuild, "Show Duplicates", %IDM_ShowDupes, %MF_Enabled
      Menu Add String, hBuild, "Case Sensitive Searches", %IDM_CaseSensitive, %MF_Enabled
      Menu Add String, hBuild, "Ignore Unimportant Differences", %IDM_Unimportant, %MF_Enabled
      Menu Add String, hBuild, "-", %IDM_Sep, %MF_Enabled
      Menu Add PopUp, hBuild, "Structures", hProcedures, %MF_Enabled

      Menu Add String, hBuild, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hBuild, "Set File Types to Scan", %IDM_SetFileExt, %MF_Enabled
      Menu Add String, hBuild, "Set Text Editor", %IDM_SetTextEditor, %MF_Enabled
      Menu Add String, hBuild, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hBuild, "Build Library From Single File", %IDM_BuildSingleFile, %MF_Enabled
      Menu Add String, hBuild, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hBuild, "Open Procedure Library", %IDM_ViewProcedureLibrary, %MF_Enabled

      Menu New PopUp To hHelp
      Menu Add String, hHelp, "Local Help", %IDM_LocalHelp, %MF_Enabled

    Menu New PopUp To hPBWin
      Menu Add String, hPBWin, "Select IDE", %IDM_SelectIDE, %MF_Enabled
      Menu Add String, hPBWin, "Select PowerBASIC Help File", %IDM_SetHelpPB, %MF_Enabled


      Menu New PopUp To hContextSci
      Menu Add String, hContextSci, "Cut", %IDM_SciCut, %MF_Enabled
      Menu Add String, hContextSci, "Copy", %IDM_SciCopy, %MF_Enabled
      Menu Add String, hContextSci, "Paste", %IDM_SciPaste, %MF_Enabled
      Menu Add String, hContextSci, "Delete", %IDM_SciDelete, %MF_Enabled
      Menu Add String, hContextSci, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hContextSci, "Clear All", %IDM_SciClear, %MF_Enabled
      Menu Add String, hContextSci, "Copy All", %IDM_SciCopyAll, %MF_Enabled
      Menu Add String, hContextSci, "-", %IDM_Sep, %MF_Enabled
      Menu Add String, hContextSci, "Undo", %IDM_SciUndo, %MF_Enabled
      Menu Add String, hContextSci, "Redo", %IDM_SciRedo, %MF_Enabled
      Menu Add String, hContextSci, "Comment", %IDM_SciComment, %MF_Enabled
      Menu Add String, hContextSci, "UnComment", %IDM_SciUnComment, %MF_Enabled
      Menu Add String, hContextSci, "Indent", %IDM_SciIndent, %MF_Enabled
      Menu Add String, hContextSci, "Outdent", %IDM_SciOutdent, %MF_Enabled
      Menu Add String, hContextSci, "Fold All", %IDM_SciFoldAll, %MF_Enabled
      Menu Add String, hContextSci, "UnFold All", %IDM_SciUnFoldAll, %MF_Enabled
      Menu Add String, hContextSci, "-",        %IDM_Sep, %MF_Enabled
      Menu Add String, hContextSci, "Remove Blank Lines", %IDM_SciRemoveBlanks, %MF_Enabled
      Menu Add String, hContextSci, "Left Justify", %IDM_SciLeftJustify, %MF_Enabled
      Menu Add String, hContextSci, "Format Code", %IDM_SciFormat, %MF_Enabled
      Menu Add String, hContextSci, "-",        %IDM_Sep, %MF_Enabled
      Menu Add String, hContextSci, "Open External File", %IDM_OpenFile, %MF_Enabled
      Menu Add String, hContextSci, "Save As External File", %IDM_SaveAsFile, %MF_Enabled
      Menu Add String, hContextSci, "-",        %IDM_Sep, %MF_Enabled
      Menu Add String, hContextSci, "Open Selection in PowerBASIC Help",  %IDM_SciOpenInHelpPB,  %MF_Enabled
      Menu Add String, hContextSci, "Open Procedure in PowerBASIC IDE",  %IDM_SciOpenInIDE,  %MF_Enabled
      Menu Add String, hContextSci, "Open Parent File in PowerBASIC IDE",  %IDM_OpenParentFileInIDE,  %MF_Enabled

End Sub

Sub SetControlFonts
    Font New FontName, FontSize, FontAttr To hFontLV
    Font New "Courier New", FontSize, FontAttr To hFontSci
    Control Set Font hDlg, %IDC_ListViewS, hFontLV
    Control Set Font hDlg, %IDC_ListView, hFontLV
    Control Set Font hDlg, %IDC_Sci, hFontSci
    Control Set Font hDlg, %IDC_SciV, hFontSci
End Sub

Sub SetFixedControlFonts
    Font New "Tahoma", 10, 0 To hFontToolbar
    Control Set Font hDlg, %IDC_Toolbar, hFontToolbar
    Control Set Font hDlg, %IDC_SearchLabel, hFontToolbar
    Control Set Font hDlg, %IDC_ComboBox, hFontToolbar
    Control Set Font hDlg, %IDC_StatusBar, hFontToolbar
End Sub

Sub InitKeyWords
    Local temp$, i As Long

    'PowerBASIC keywords
    ReDim UWords(1000), LWords(1000), MWords(1000)
    Open Exe.Path$ + "files\keywords.txt" For Input As #1
    While IsFalse Eof(1)
       Line Input #1, temp$
       If Len(Trim$(temp$)) Then
            MWords(i) = temp$
            UWords(i) = UCase$(MWords(i))
            LWords(i) = LCase$(MWords(i))
            Incr i
       End If
    Wend
    Close #1
    ReDim Preserve UWords(i-1), LWords(i-1), MWords(i-1)

    'Intellisense arrays
    Dim Ref_Term1(0), Ref_Desc1(0), Ref_Syntax1(0)
    Dim Ref_Term2(0), Ref_Desc2(0), Ref_Syntax2(0)
    Dim Ref_Term3(0), Ref_Desc3(0), Ref_Syntax3(0)
    Dim Ref_MemTerm1(0), Ref_MemMember1(0)
    Dim Ref_MemTerm2(0), Ref_MemMember2(0)
    LoadRef "files\words1.txt", Ref_Term1(), Ref_Syntax1()
    LoadRef "files\words2.txt", Ref_Term2(), Ref_Syntax2()
    LoadRef "files\words3.txt", Ref_Term3(), Ref_Syntax3()
    LoadRef "files\members1.txt", Ref_memTerm1(), Ref_memMember1()
    LoadRef "files\members2.txt", Ref_memTerm2(), Ref_memMember2()
End Sub

Sub InitSciControl(hScintilla As Dword)
    Local fName As String

    'use spaces, not tabs
    SendMessage hScintilla, %SCI_SetUseTabs, 0, 0
    SendMessage hScintilla, %SCI_SetTABWidth, 3, 0

    'margins
    SendMessage hScintilla, %SCI_SetMarginWidthN, 0, 0  'hide line number margin
    SendMessage hScintilla, %SCI_SetMarginWidthN, 1, 0  'hide symbols margin
    SendMessage hScintilla, %SCI_SetMarginWidthN, 2, 0  'hide folding margin
    SendMessage hScintilla, %SCI_SetMarginMaskN,  2, %SC_Mask_Folders 'margin 2 is folding margin
    SendMessage hScintilla, %SCI_SetMarginSensitiveN,  2, 1           'maring 2 is sensitive to clicks

    fName = FontNameSci + $Nul
    SendMessage hScintilla, %Sci_StyleSetFont, %Style_Default, StrPtr(fName)  'default style to Courier new
    SendMessage hScintilla, %SCI_StyleSetSize, %Style_Default, FontSize&      'default style size to 10 points
    SendMessage hScintilla, %SCI_StyleSetBold, %Style_Default, FontAttr       'default style is BOLD
    SendMessage hScintilla, %Sci_StyleClearAll, 0, 0                          'set all styles to default

    'show margins
    SendMessage hScintilla, %SCI_SetMarginWidthN, 0, IIf(LineNumbers, 40, 0)  'display line numbers
    SendMessage hScintilla, %SCI_SetMarginWidthN, 2, IIf(CodeFolding, 20, 0)         'display fold symbols
    SendMessage hScintilla, %SCI_SetMarginLeft,   0, IIf(CodeFolding, 1, 5)          'display line numbers

    'set folding markers/symbols
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderOpen, %SC_Mark_CircleMinus
   SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_Folder, %SC_Mark_CirclePlus
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderSub, %SC_Mark_VLine
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderTail, %SC_Mark_LCornerCurve
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderEnd, %SC_Mark_CirclePlusConnected
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderOpenMid, %SC_Mark_CircleMinusConnected
    SendMessage hScintilla, %SCI_MarkerDefine, %SC_MarkNum_FolderMidTail, %SC_Mark_TCornerCurve
'   SendMessage hScintilla, %SCI_MarkerSetFore, %SC_MarkNum_Folder, %Red
'   SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_Folder, %Red
'   SendMessage hScintilla, %SCI_MarkerSetFore, %SC_MarkNum_FolderOpen, %Red
'   SendMessage hScintilla, %SCI_MarkerSetback, %SC_MarkNum_FolderOpen, %Red
    SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_FolderSub, %Black
    SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_FolderTail, %Black
'   SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_FolderEnd, %Black
'   SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_FolderOpenMid, %Black
'   SendMessage hScintilla, %SCI_MarkerSetBack, %SC_MarkNum_FolderMidTail, %Black


    'lexer styles
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_Comments,  ColorComments  'RGB(0,100,0)
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_Keywords,  ColorKeywords  '%Blue
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_Strings,   ColorStrings   '%Red
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_Numbers,   %Gray
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_Operators, %Green

    'create 2 background markers, each with a different background color
    SendMessage hScintilla, %SCI_MarkerDefine, %Style_Dark,%SC_MARK_BACKGROUND
    SendMessage hScintilla, %SCI_MarkerSetBack, %Style_Dark, RGB(235,235,235)   'more gray background
    SendMessage hScintilla, %SCI_MarkerDefine, %Style_Light,%SC_MARK_BACKGROUND
    SendMessage hScintilla, %SCI_MarkerSetBack, %Style_Light, %White   'less gray background

    'menu/event mask/internal lexer
    SendMessage hScintilla, %SCI_UsePopup, 0, 0                         'turn OFF context menu
    SendMessage hScintilla, %SCI_SETMODEVENTMASK, %SC_MOD_INSERTTEXT Or %SC_MOD_DELETETEXT, 0   'only msgs on text changes
    SendMessage hScintilla, %SCI_SetLexer,  %SCLEX_Container, 0         'container does lexing

    'hotspot style for URLs
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_HotSpot,  %rgb_DarkBlue
   SendMessage hScintilla, %SCI_StyleSetHotSpot, %Style_HotSpot, 1   'activate hotspot in %Style_HotSpot
    SendMessage hScintilla, %SCI_SetHotSpotActiveFore, 1, %Blue       'blue FG when mouse hovers
    SendMessage hScintilla, %SCI_SetHotSpotActiveUnderline, 1, 0      'enable underlining
    SendMessage hScintilla, %SCI_SetHotSpotSingleLine, 1, 0               'do not allow wrap of hotspot

    'brace highlighting color
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_BraceLight, %Red    'set brace highlighting color
    SendMessage hScintilla, %SCI_StyleSetBack, %Style_BraceLight, %Yellow 'set brace highlighting color
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_BraceBad, %Green    'set brace bad color
    SendMessage hScintilla, %SCI_StyleSetBack, %Style_BraceBad, %Red     'set brace bad color

    'set indent size to 4 spaces
    SendMessage hScintilla, %SCI_SetIndent, 3, 0             'set indent size to 4 spaces
    SendMessage hScintilla, %SCI_SetTABIndents, 1, 0         'force TAB to indent within white space area
    SendMessage hScintilla, %SCI_SetBackspaceUnindents, 1, 0 'force backspace to unindent within white space area
    SendMessage hScintilla, %SCI_StyleSetFore, %Style_IndentGuide, %Red
    If IndentationGuides Then
         SendMessage hScintilla, %Sci_SetIndentationGuides, %SC_IV_LookBoth, 0
    Else
         SendMessage hScintilla, %Sci_SetIndentationGuides, %SC_IV_None, 0
    End If

    'intellisense
    ListSeparator = Asc(".")   'not use space because PowerBASIC uses 3-word keyword groups
    SendMessage hScintilla, %SCI_AutoCSetSeparator, ListSeparator, 0  'set separator

End Sub

Sub LoadRef (sFile$, ArrayTerm() As String, ArraySyntax() As String)
      'load any of the 5 reference files - all use the same content format   sWord:::::sSyntax
      Local temp$, i As Long
      Open sFile$ For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
      temp$ = RTrim$(temp$,$CrLf)
      ReDim ArrayTerm(ParseCount(temp$,$CrLf)-1) As String, ArraySyntax(UBound(ArrayTerm)) As String
      Parse temp$,ArrayTerm(),$CrLf
      For i = 0 To UBound(ArrayTerm)
            ArraySyntax(i) = Parse$(ArrayTerm(i),":::::", 2)
            ArrayTerm(i) = Parse$(ArrayTerm(i),":::::", 1)
      Next i
End Sub

Sub CustomPBLexer (ByVal iStartPos As Long, ByVal iEndPos As Long, hScintilla As Dword)
    Local iLine, iStartLine, iEndLine As Long
    SyntaxInWork = 1
    iStartLine  = SendMessage(hScintilla, %SCI_LineFromPosition,iStartPos,0) 'start line
    iEndLine = SendMessage(hScintilla, %SCI_LineFromPosition,iEndPos,0)      'end line
    For iLine = iStartLine To iEndLine
         If GreenBars Then CreateGreenLine(iLine,hScintilla)
         If SyntaxHighlighting Then LexOneLine(iLine,hScintilla)
         If URLRecognition Then CreateURLHotSpots(iLine,hScintilla)
    Next iLine
    If CodeFolding Then SetFoldLevels(hScintilla)
    SyntaxInWork = 0
End Sub

Sub CreateURLHotSpots(iLine As Long, hScintilla As Dword)
    'set hotspot for each URL in the given line
    Local iResult, iStartPos, iEndPos As Long
    iStartPos = SendMessage(hScintilla,%SCI_PositionFromLine,iLine,0)      'first char in line
    iEndPos = SendMessage( hScintilla, %SCI_GetLineEndPosition, iLine, 0)  'last char in line

    iResult = FindNextHTTP(iStartPos, iEndPos, hScintilla)  'find next occurrence of http://
    Do While iResult > -1
         SendMessage hScintilla, %SCI_StartStyling, FindStructure.ChrgText.cpmin, 31
         SendMessage hScintilla, %SCI_SetStyling, FindStructure.ChrgText.cpmax - FindStructure.ChrgText.cpmin, %Style_HotSpot
         iResult = FindNextHTTP(iStartPos,iEndPos,hScintilla)
         If iResult > -1 Then iStartPos = FindStructure.chrgtext.cpmax
    Loop
End Sub

Sub SetFoldLevels(hScintilla As Dword)
    Local InSnippet, InProcFlag, iLine, iLineCount, iLineLength, iLevel As Long
    Local Txt As String

    RemoveFoldSymbols hScintilla

    'rebuild folder levels and symbol assignment
    iLineCount = SendMessage( hScintilla, %SCI_GetLineCount, 0, 0)    'number of lines
    For iLine = 0 To iLineCount - 1
         iLineLength = SendMessage( hScintilla, %SCI_LineLength , iLine, 0)    'get line width
         Txt = String$(iLineLength," ") + $Nul                           'set buffer length
         SendMessage hScintilla, %SCI_GetLine , iLine, StrPtr(Txt)             'get line text
         If Left$(Txt,19) = "'Compilable Example" Then InSnippet = 1
         If InSnippet = 0 Then
               SendMessage hScintilla, %SCI_SetFoldLevel, iLine, 0
               Iterate For
         End If
         Txt = LCase$(Txt)                                               'lower case for comparison
         If     Left$(Txt,5) = "type " Or _
                   Left$(Txt,6) = "union " Or _
                   Left$(Txt,4) = "sub " Or _
                   Left$(Txt,6) = "macro " Or _
                   Left$(Txt,9) = "callback " Or _
                   (Left$(Txt,9)= "function " And LCase$(Left$(Txt,10)) <> "function =") Or _
                   Left$(Txt,6) = "class " Or _
                   Left$(Txt,10)= "interface " Or _
                   Left$(Txt,7) = "method " Or _
                   Left$(Txt,9) = "property " Then
             iLevel = 1
         ElseIf Left$(Txt,8) = "end type" Or _
                   Left$(Txt,9) = "end union" Or _
                   Left$(Txt,7) = "end sub" Or _
                   Left$(Txt,9) = "end macro" Or _
                   Left$(Txt,12)= "end function" Or _
                  Left$(Txt,9) = "end class" Or _
                   Left$(Txt,13)= "end interface" Or _
                   Left$(Txt,10)= "end method" Or _
                   Left$(Txt,12)= "end property" Then
             iLevel = 3
       Else
             iLevel = 2
         End If

         Select Case iLevel
             Case 1     'fold point  i.e., Type
                  SendMessage hScintilla, %SCI_SetFoldLevel, iLine, iLevel Or %SC_FoldLevelHeaderFlag
'            SendMessage hScintilla, %SCI_MarkerAdd, iLine, %SC_MarkNum_FolderOpen
                  InProcFlag = 1
             Case 2
                  If InProcFlag = 1 Then    'between fold point and fold end point
                      SendMessage hScintilla, %SCI_SetFoldLevel, iLine, iLevel
                      SendMessage hScintilla, %SCI_MarkerAdd, iLine, %SC_MarkNum_FolderSub
                  End If
             Case 3
                  If InProcFlag = 1 Then   'at fold end point  i.e., "End Type
                      SendMessage hScintilla, %SCI_SetFoldLevel, iLine, iLevel
                      SendMessage hScintilla, %SCI_MarkerAdd, iLine, %SC_MarkNum_FolderTail
                      InProcFlag = 0
                  End If
         End Select
    Next iLine
End Sub

Function WordsToLeft(WA As String, WB As String, WC As String, iPos As Long, hScintilla As Dword) As Long
    Local iCount, iLine, iStart As Long, LeftText As String, TR As Sci_TextRange

    'get LeftText
    iLine  = SendMessage( hScintilla, %SCI_LineFromPosition, iPos, 0)  'line that contains iPos
    iStart  = SendMessage( hScintilla, %SCI_PositionFromLine, iLine, 0)  'position of 1st char in line
    TR.chrg.cpmin = iStart  'first character to get
    TR.chrg.cpmax = iPos-1    'last character to get
    LeftText = String$(iPos-iStart, " ") + $Nul
    TR.lpstrText = StrPtr(LeftText)
    SendMessage hScintilla, %SCI_GetTextRange, 0, VarPtr(TR)  'get range of text
    LeftText = Trim$(TR.@lpstrText)
    LeftText = Retain$(LeftText, Any Chr$(65 To 90, 97 To 122, 48 To 57, $Spc, "$&#%?!"))  'remove all but word characters

    'get right-most 3 words of text
    iCount = ParseCount(LeftText, " ")
    WC = Parse$(LeftText," ",iCount)
    WB = Parse$(LeftText," ",iCount-1)
    WA = Parse$(LeftText," ",iCount-2)
End Function

Function GetHotSpotText (iPos As Long, hScintilla As Dword) As String
    Local TR As Sci_TextRange
    Local i,iMax,iStyle,iNewStyle,iStart,iEnd As Long
    Local URL As String
    iStyle = SendMessage(hScintilla, %SCI_GetStyleAt, iPos, 0)
    iMax = SendMessage(hScintilla, %SCI_GetLength, 0, 0)

    'go up to get the right-most character with the style
    i = iPos : iNewStyle = iStyle : iEnd = iPos
    While (iStyle = iNewStyle) And (i < iMax)
         iEnd = i
         Incr i
         iNewStyle = SendMessage(hScintilla, %SCI_GetStyleAt,i,0)
    Wend

    'go down to get left-most character with the style
    i = iPos : iNewStyle = iStyle : iStart = iPos
    While (iStyle = iNewStyle) And (i > -1)
         iStart = i
         Decr i
         iNewStyle = SendMessage(hScintilla, %SCI_GetStyleAt,i,0)
    Wend

    'get the text
    TR.chrg.cpmin = iStart    'first character to get
    TR.chrg.cpmax = iEnd + 1  'last character to get
    TR.lpstrText = StrPtr(URL)
    SendMessage hScintilla, %SCI_GetTextRange, 0, VarPtr(TR)  'get range of text
    Function = TR.@lpstrText
End Function

Function Intellisense(iPos As Long, CharAtLeft As String, hScintilla As Dword) As String
    Local WA, WB, WC, sSyntax, sTips As String
    Local LeftPos, iReturn As Long

    'get prior 3 words
    WordsToLeft(WA,WB,WC,iPos,hScintilla)
'   Dialog Set Text hDlg, "Pos: " + Str$(iPos) + "  Char: " + CharAtLeft + " " _
'             + "  Words:  " +  "___" + WA + " " + WB + " " + WC + "___"

    If Len(WA) And BSearch(Build$(WA,$Spc,WB,$Spc,WC), iReturn, Ref_Term3(), Ref_Syntax3()) Then
          '3 word sequence was found - display arguments
          sSyntax = Ref_Syntax3(iReturn)
          sTips = WA + $Spc + WB + $Spc + WC + $Spc + sSyntax
          If CallTips Then If Len(sSyntax) Then SendMessage hScintilla, %SCI_CallTipShow, iPos, StrPtr(sSyntax)
    ElseIf Len(WB) And BSearch(Build$(WB,$Spc,WC), iReturn, Ref_memTerm2(), Ref_memMember2()) Then
            '2 word sequence was found - display 3rd members
          sSyntax = Ref_memMember2(iReturn)
          sTips = WA + $Spc + WB + $Spc + WC + $Spc + sSyntax
          If AutoCompletion Then If Len(sSyntax) Then SendMessage hScintilla, %SCI_AutoCShow, LeftPos, StrPtr(sSyntax)
    ElseIf Len(WB) And BSearch(Build$(WB,$Spc,WC), iReturn, Ref_Term2(), Ref_Syntax2()) Then
            '2 word sequence was found with syntax - display arguments
          sSyntax = Ref_Syntax2(iReturn)
          sTips = WB + $Spc + WC + $Spc + sSyntax
          If CallTips Then If Len(sSyntax) Then SendMessage hScintilla, %SCI_CallTipShow, iPos, StrPtr(sSyntax)
    ElseIf Len(WC) And BSearch(WC, iReturn, Ref_memTerm1(), Ref_memMember1()) Then
            '1 word sequence was found - display 2nd member
          sSyntax = Ref_memMember1(iReturn)
          sTips = WB + $Spc + WC + $Spc + sSyntax
          If AutoCompletion Then If Len(sSyntax) Then SendMessage hScintilla, %SCI_AutoCShow, LeftPos, StrPtr(sSyntax)
    ElseIf Len(WC) And BSearch(WC, iReturn, Ref_Term1(), Ref_Syntax1()) Then
            '1 word sequence was found - display arguments
          sSyntax = ModifySyntax(CharAtLeft, Ref_Syntax1(iReturn))
          sTips = WC + $Spc + sSyntax
          If CallTips Then If Len(sSyntax) Then SendMessage hScintilla, %SCI_CallTipShow, iPos, StrPtr(sSyntax)
    Else
          'no matches were found close call tips and autocomplete
          SendMessage hScintilla, %SCI_CallTipCancel, 0, 0
          SendMessage hScintilla, %SCI_AutoCCancel, 0, 0
      End If
      If PersistentCallTips Then Function = sTips
End Function

Sub SmartIndentation (iPos As Long, hScintilla As Dword)
    Local nChars, iLine, iReturn As Long, temp$
    iLine  = SendMessage( hScintilla, %SCI_LineFromPosition, iPos, 0)         'new line #
   iReturn = SendMessage( hScintilla, %SCI_GetLineIndentation, iLine-1, 0)   'indentation, previous line

    'get additional spaces for specific constructs
    nChars = SendMessage( hScintilla, %SCI_LineLength , iLine-1, 0) 'get line width
    temp$ = String$(nChars, " ") + $Nul                       'set buffer length
    SendMessage hScintilla, %SCI_GetLine , iLine-1, StrPtr(temp$)   'get line text

    'look for leading construct that requires additional indentation
    temp$ = LCase$(Trim$(temp$, Any Chr$($CrLf, 32, 9, 0)))   'current line text
    If Left$(temp$,3) = "if "  Or _
         Left$(temp$,5) = "else " Or _
         Left$(temp$,7) = "select " Or _
         Left$(temp$,5) = "case " Or _
         Left$(temp$,3) = "for " Or _
         Left$(temp$,3) = "do " Or _
         Left$(temp$,5) = "loop " Or _
         temp$ = "do" Or _
         Left$(temp$,5) = "else " Or _
         Left$(temp$,6) = "while " Then
         temp$ = Space$(iReturn + IndentSize) + $Nul
    Else
         temp$ = Space$(iReturn) + $Nul
    End If

    SendMessage hScintilla, %SCI_ReplaceSel,0, StrPtr(temp$)
End Sub

Sub CreateGreenLine(iLine As Long, hScintilla As Dword)
    SendMessage hScintilla, %SCI_MarkerDelete, iLine, %Style_Light
    SendMessage hScintilla, %SCI_MarkerDelete, iLine, %Style_Dark
    If GreenBars Then
         Select Case iLine Mod 6
             Case 0,1,2
                  SendMessage hScintilla, %SCI_MarkerAdd, iLine, %Style_Light  'line, marker#
             Case 3,4,5
                  SendMessage hScintilla, %SCI_MarkerAdd, iLine, %Style_Dark    'line, marker#
         End Select
    Else
         SendMessage hScintilla, %SCI_MarkerAdd, iLine, %Style_Light         'line, marker#
    End If
End Sub

Sub LexOneLine(iLine As Long, hScintilla As Dword)
    Local I, iStart, iEnd, iLineLength, wFlag, StopPos, iResult,rr As Long
    Local Txt, xWord As String
    Local Letter As Byte Ptr

    iStart  = SendMessage( hScintilla, %SCI_PositionFromLine, iLine, 0)   'position of 1st char in line
    iEnd    = SendMessage( hScintilla, %SCI_GetLineEndPosition, iLine, 0) 'postion of last char in line
    iLineLength = SendMessage( hScintilla, %SCI_LineLength , iLine, 0)    'get line width
    Txt = String$(iLineLength," ") + $Nul                           'set buffer length
    SendMessage hScintilla, %SCI_GetLine , iLine, StrPtr(Txt)                 'get line text
    Txt = UCase$(Txt)   'CharUpperBuff(ByVal StrPTR(Buf), iLineLength)  'Make UCASE
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ' Loop through each character in the line, using a pointer for better speed
    '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    Letter = StrPtr(Txt) : wFlag = 0
    For I = 1 To Len(Txt)
         Select Case @Letter 'The characters we need to inlude in a word
             Case 97 To 122, 65 To 90, 192 To 214, 216 To 246, 248 To 255, 35 To 38, 48 To 57, 63, 95
                  If wFlag = 0 Then
                      wFlag = 1 : stopPos = I
                  End If

             Case 34 ' string quotes -> "
                  stopPos = InStr(I + 1, Txt, Chr$(34)) 'Find match
                  If StopPos Then
                      SendMessage(hScintilla, %SCI_StartStyling,iStart + I,31)
                      SendMessage(hScintilla, %SCI_SetStyling, StopPos - 1 - I, %Style_Strings) 'style iLineLength characters
                      StopPos = (StopPos - I + 1)
                      I = I + StopPos
                      Letter = Letter + StopPos
                      wFlag = 0
                  End If

             Case 39 ' comment character -> '
                  SendMessage(hScintilla, %SCI_StartStyling,iStart + I - 1,31)
                  SendMessage(hScintilla, %SCI_SetStyling, iLineLength - I + 1, %Style_Comments)
                  wFlag = 0
                  Exit For

             Case Else  'word is ready
                  If wFlag = 1 Then
                      xWord = Mid$(Txt, stopPos, I - stopPos)  'Get word
                      If xWord = "REM" Then  'extra for the uncomment word, REM
                           SendMessage(hScintilla, %SCI_StartStyling,iStart + I - Len(xWord) - 1,31)
                           SendMessage(hScintilla, %SCI_SetStyling, iLineLength - I + Len(xWord) + 1, %Style_Comments)
                           wFlag = 0
                           Exit For
                      End If
                      Array Scan UWords(0), = xWord, To iResult  'Is it in the array?
'---------------------------------------------------------------------------------------
                      If iResult And CodeCase = 1 Then
                           'turn off Undo so can change word to Mixed without flagging file as dirty
                           SendMessage hScintilla, %SCI_SetUndoCollection, 0, 0
                           xWord = MWords(iResult-1)
                           SendMessage hScintilla, %SCI_SetTargetStart, iStart + I - Len(xWord) - 1, 0
                           SendMessage hScintilla, %SCI_SetTargetEnd, iStart + I - 1, 0
                           SendMessage hScintilla, %SCI_ReplaceTarget, Len(xWord) ,StrPtr(xWord)
                           rr = SendMessage(hScintilla, %SCI_GetCurrentPos, 0, 0) + Len(xWord)
                           SendMessage hScintilla, %SCI_SetAnchor, rr, 0
                           SendMessage hScintilla, %SCI_SetCurrentPos, rr, 0
                           'restart Undo
                           SendMessage hScintilla, %SCI_SetUndoCollection, 1, 0
                           SendMessage hScintilla, %SCI_StartStyling,iStart + StopPos - 1, 31
                           SendMessage hScintilla, %SCI_SetStyling, I - StopPos, %Style_Keywords
'---------------------------------------------------------------------------------------
                      Else
                           SendMessage(hScintilla, %SCI_StartStyling,iStart + StopPos - 1,31)
                           SendMessage(hScintilla, %SCI_SetStyling, I - StopPos, IIf(iResult, %Style_Keywords,%Style_Default))
                      End If
                      wFlag = 0
                  End If
         End Select
         Incr Letter
    Next I

End Sub

Function FindNextHTTP(iStartPos As Long, iEndPos As Long, hScintilla As Dword) As Long
    Local FindURLText As String
    FindURLText = "\<http://[()-.:/#%A-za-z0-9?=]*" + Chr$(0)   'word starting with http
    FindStructure.Chrg.cpMin = iStartPos
    FindStructure.Chrg.cpMax = iEndPos
    FindStructure.lpstrText = StrPtr(FindURLText)
    Function = SendMessage (hScintilla, %SCI_FindText, %SCFind_RegExp, VarPtr(FindStructure))  '-1 if not found, otherwise start pos
End Function

Sub RemoveFoldSymbols(hScintilla As Dword)
    'remove all folder symbols from all ines
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_Folder, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderOpen, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderTail, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderSub, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderEnd, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderOpenMid, 0
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderMidTail, 0
End Sub

Function BSearch(ByVal sWord As String, iArrayPos&, ArrayTerm() As String, ArraySyntax() As String) As Long
      Local Upper As Long, Lower As Long
      Lower = LBound(ArrayTerm) : Upper = UBound(ArrayTerm) : sWord = LCase$(sWord)
      'test boundary values
      If sWord = ArrayTerm(Lower) Then iArrayPos& = Lower : Function = 1 : Exit Function
      If sWord = ArrayTerm(Upper) Then iArrayPos& = Upper : Function = 1 : Exit Function
      If sWord < ArrayTerm(Lower) Then iArrayPos& = Lower - 1 : Function = 0 : Exit Function
      If sWord > ArrayTerm(Upper) Then iArrayPos& = Upper + 1 : Function = 0 : Exit Function
      'loop through remaining entries until searchterm found, or it's determined that term is not in the array
      Do Until (Upper <= (Lower+1))
            iArrayPos& = (Lower + Upper) / 2
            If sWord > ArrayTerm(iArrayPos&) Then
                Lower = iArrayPos&
            ElseIf sWord < ArrayTerm(iArrayPos&) Then
                Upper = iArrayPos&
            Else
                Function = 1 : Exit Function
            End If
      Loop
End Function

Function ModifySyntax (sChar$, ByVal sSyntax$) As String
'    If sChar$ = " " AND Left$(sSyntax$,1) = "(" Then             'optional way to skip leading (
'        sSyntax$ = Mid$(sSyntax$, 2, Len(sSyntax$)-2)
      If sChar$ = "(" And Left$(sSyntax$,1) = "(" Then
          sSyntax$ = Mid$(sSyntax$, 2)         'do not allow ((
      ElseIf sChar$ = "(" And Left$(sSyntax$,1) <> "(" Then
          sSyntax$ = ""                        'if sChar is (, then sSyntax must also start with (, otherwise, don't show sSyntax
      End If
      Function = sSyntax$
End Function

Sub LoadSampleCode(hScintilla As Dword)
    Local temp$
    Open "files\sample.bas" For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1
    Sci_SetText hScintilla, temp$
End Sub

Sub SciFoldAll(Scintilla As Dword)
    Local iLevel, iExpanded, iLine, iLineCount As Long
    iLineCount = SendMessage( Scintilla, %SCI_GetLineCount, 0, 0)    'number of lines
    For iLine = 0 To iLineCount - 1
         iExpanded = SendMessage( Scintilla, %SCI_GetFoldExpanded, iLine, 0)
         iLevel = (SendMessage (Scintilla, %SCI_GetFoldLevel, iLine, 0) And %SC_FoldLevelNumberMask)
         If iExpanded = 1 And iLevel = 1 Then
               SendMessage Scintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderOpen, 0
               SendMessage Scintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_Folder, 0
               SendMessage Scintilla, %SCI_ToggleFold,iLine,0
         End If
    Next i
End Sub

Sub SciUnFoldAll(Scintilla As Dword)
    Local iLevel, iExpanded, iLine, iLineCount As Long
    iLineCount = SendMessage( Scintilla, %SCI_GetLineCount, 0, 0)    'number of lines
    For iLine = 0 To iLineCount - 1
         iExpanded = SendMessage( Scintilla, %SCI_GetFoldExpanded, iLine, 0)
         iLevel = (SendMessage (Scintilla, %SCI_GetFoldLevel, iLine, 0) And %SC_FoldLevelNumberMask)
         If iExpanded = 0 And iLevel = 1 Then
               SendMessage Scintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_FolderOpen, 0
               SendMessage Scintilla, %SCI_MarkerDeleteAll, %SC_MarkNum_Folder, 0
               SendMessage Scintilla, %SCI_ToggleFold,iLine,0
         End If
    Next i
End Sub

Function SciOpenInHelpPB(hScintilla As Dword) As String
         Local skey As WStringZ * %Max_Path, kw As HH_AKLINK
         If IsFalse(IsFile(PathHelpPB)) Then Beep : Exit Function
         sKey = Trim$(Sci_GetSelText(hScintilla))
         kw.cbStruct = SizeOf(kw)   ' Build the HtmlHelp's Keyword look up UDT
         kw.pszKeywords = VarPtr(skey)
         kw.fIndexOnFail = %True
       HtmlHelp(hDlg, PathHelpPB, %HH_KEYWORD_LOOKUP, VarPtr(kw))
End Function


Sub PrintContent(hScintilla As Dword)                         'print content of currently selected TAB
    Local temp$, i,j As Long

    'put content into an array
    temp$ = Sci_GetText(hScintilla)
    If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla)
    Dim TempArray(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, TempArray(), $CrLf
    'print the array
    XPrint Attach Choose
    If Len(XPrint$) = 0 Then Exit Sub
    For i = 0 To UBound(TempArray())
         If (i Mod LinesPerPage) = 0 Then
             If i <> 0 Then XPrint FormFeed
             For j = 1 To 5 : XPrint : Next j
         End If
         XPrint TempArray(i)
    Next i
    XPrint Close
End Sub

Sub LexAll(hScintilla As Dword)
      Local iCurrentPos, iStartPos, iEndPos As Long
      iCurrentPos = SendMessage( hScintilla, %SCI_GetCurrentPos, 0, 0)  'get caret position
      iStartPos = 0
      iEndPos = SendMessage(hSci, %SCI_GetLength, 0,0)
      If (SplitVAInWork = 0) And (SplitHAInWork = 0) Then CustomPBLexer iStartPos, iEndPos, hSci
      SendMessage ( hScintilla, %SCI_SetSel, iCurrentPos, iCurrentPos)  'get caret position
End Sub

Sub StyleAllDefault(hScintilla As Dword)
    Local iLine, iLineCount, iLength As Long
    iLineCount = SendMessage(hScintilla, %SCI_GetLineCount,0,0)  'ending line
    iLength = SendMessage(hScintilla, %SCI_GetLength, 0,0)       '#chars in document
    SendMessage(hScintilla, %SCI_StartStyling, 0, 31)  'iMask=31 if not changing indicators
    SendMessage(hScintilla, %SCI_SetStyling, iLength, %Style_Default)
    For iLine = 0 To iLineCount - 1
         If URLRecognition Then CreateURLHotSpots iLine, hSci
    Next iLine
    If GreenBars Then CreateGreenBars(1,hSci) 'Else CreateGreenBars(0)
End Sub

Sub ShowMargins(hScintilla As Dword)
    If LineNumbers Then
         SendMessage hScintilla, %SCI_SetMarginWidthN, 0, 40  'display line numbers
    Else
         SendMessage hScintilla, %SCI_SetMarginWidthN, 0, 0  'display line numbers
    End If

    If CodeFolding Then
         SendMessage hScintilla, %SCI_SetMarginWidthN, 2, 20  'display fold symbols
         SendMessage hScintilla, %SCI_SetMarginLeft, 0, 1  'display line numbers
    Else
         SendMessage hScintilla, %SCI_SetMarginWidthN, 2, 0  'display fold symbols
         SendMessage hScintilla, %SCI_SetMarginLeft, 0, 5  'display line numbers
    End If
End Sub

Sub SetCodeStyle(hScintilla As Dword)
      Select Case CodeCase
            Case 0,1 : SendMessage hScintilla, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Mixed
            Case 2 : SendMessage hScintilla, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Lower
            Case 3 : SendMessage hScintilla, %Sci_StyleSetCase, %Style_Keywords, %SC_Case_Upper
      End Select
End Sub

Sub CreateGreenBars(Flag As Long, hScintilla As Dword)
    Local i, iLines As Long
    iLines = SendMessage(hScintilla, %SCI_GetLineCount, 0, 0)
    'assign different marker to each group of 3 lines
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %Style_Light, 0   'first, remove all markers
    SendMessage hScintilla, %SCI_MarkerDeleteAll, %Style_Dark, 0   'first, remove all markers
    If Flag = 0 Then Exit Sub
    For i = 0 To iLines - 1
'      SendMessage hScintilla, %SCI_SetMarginMaskN, 1, Not %SC_Mask_Folders   'all symbols allowed
         If Flag Then
             Select Case i Mod 6
                  Case 0,1,2
                      SendMessage hScintilla, %SCI_MarkerAdd, i, %Style_Light  'line, marker#
                  Case 3,4,5
                      SendMessage hScintilla, %SCI_MarkerAdd, i, %Style_Dark    'line, marker#
             End Select
         Else
             SendMessage hScintilla, %SCI_MarkerAdd, i, %Style_Light         'line, marker#
         End If
    Next i
End Sub

Sub SetFileExt
    Local x,y As Long, temp$
    Dialog Get Loc hDlg To x,y
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    temp$ = InputBox$("", "Set Local Procedure Library File Extension", FileExt, x+100,y+100)
    UnhookWindowsHookEx ghHook
    If Len(temp$) Then FileExt = temp$
End Sub

Function SelectColor(FirstColor As Long) As Long
    Local ColorResult&, Flags&
    Flags& = %CC_FullOpen      'PreventFullOpen
    Display Color hDlg, 100, 100, FirstColor, CustomColorList ,Flags& To ColorResult&
    If ColorResult& = -1 Then
         Function = FirstColor
    Else
         Function = ColorResult&
    End If
End Function

Sub ManageScreenContent
    Local pDocLeft, pDocRight As Dword

    pDocLeft  = Sci_GetDocPointer(hSci)
    pDocRight = Sci_GetDocPointer(hSciV)

    'set new content
    Select Case ViewMode
         Case "SingleView"
             If pDocLeft = pDocRight Then Sci_SetDocPointer(hSciV, 0)
         Case "SplitScreen"
             Sci_SetDocPointer hSciV, pDocLeft   'standard split screen - two view of same
         Case "DualView"
             If pDocLeft = pDocRight Then Sci_SetDocPointer(hSciV, 0)
             Sci_SetText hSciV, RightView 'side by side view of two different procedures
    End Select
End Sub

Sub SciOpenInIDE(hScintilla As Dword)
    Local iReturn As Long, temp$
    If IsFalse(IsFile(PathIDE)) Then Beep : Exit Sub
    temp$ = Sci_GetText(hScintilla)
    Open $TempSourceCode For Output As #1
    Print #1, temp$
    Close #1
    iReturn = Shell(PathIDE + " " + $TempSourceCode, 1)  : Exit Sub   'does not wait
End Sub

Sub SelectIDE
      Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
      title$ = "Select IDE"    'caption title. if "", then "Open" is displayed
      filter$ = "PBWin IDE" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      sfolder$ = PathIDE    'initial folder to be displayed
      If IsFile(PathIDE) Then
          startfile$ = PathIDE       'name to be used as initial selection
      Else
          startfile$ = ""
      End If
      defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
      flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
      Display Openfile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, _
                                             defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then PathIDE = filevar$
End Sub

Sub SelectHelpPB
      Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
      title$ = "Select PowerBASIC Help"    'caption title. if "", then "Open" is displayed
      filter$ = "Help Files" + $Nul + "*.chm" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      sfolder$ = PathHelpPB    'initial folder to be displayed
      If IsFile(PathHelpPB) Then
          startfile$ = PathHelpPB       'name to be used as initial selection
      Else
          startfile$ = ""
      End If
      defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
      flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
      Display Openfile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, _
                                             defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then PathHelpPB = filevar$
End Sub

Sub SelectTextEditor
      Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
      title$ = "Select Text Editor"    'caption title. if "", then "Open" is displayed
      filter$ = "Applications" + $Nul + "*.exe" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      sfolder$ = PathTextEditor    'initial folder to be displayed
      If IsFalse(IsFile(PathTextEditor)) Then startfile$ = "NotePad.exe"    'name to be used as initial selection
      defaultext$ = "exe"                 'default extension to append to selection if user does not enter it
      flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
      Display Openfile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, _
                                             defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then PathTextEditor = filevar$
End Sub

Function SelectSingleFile() As Long
      Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
      title$ = "Select Single File for Build"    'caption title. if "", then "Open" is displayed
      filter$ = "Source Code Files" + $Nul + FileExt + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      sfolder$ = SingleFile    'initial folder to be displayed
      flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
      Display Openfile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, _
                                             defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then SingleFile = filevar$ : Function = 1
End Function

Function LibraryFileIndex() As String
    Function = PathName$(Path, LibraryFileName) + PathName$(Name, LibraryFileName) + ".idx"
End Function

Function LibraryFileIndexS() As String
    Function = PathName$(Path, LibraryFileName) + PathName$(Name, LibraryFileName) + "_s.idx"
End Function

Sub SetStartFolder
    Local title$, start$, flags&, folder$
    title$ = "Select Parent Folder (Contain Source Code File to be Indexed)"    'if "" then "Open" is used
    start$ = StartFolder
    flags& = %BIF_ReturnOnlyFSDirs Or %BIF_DontGoBelowDomain Or %BIF_NoNewFolderButton
    Display Browse  hDlg, 100, 100, title$, start$, flags& To folder$
    'folder$ is set to "" if Cancel/Escape is pressed
    If Len(folder$) Then StartFolder = folder$
End Sub

Sub LoadIndex
    If IsFile(LibraryFileIndex) Then
         Open LibraryFileIndex For Binary As #1
         ReDim LC(Lof(1) / SizeOf(LocalCodeType)-1)
         Get #1, , LC()
         Close #1
    Else
         ReDim LC(0)
    End If
End Sub

Sub LoadIndexS
    If IsFile(LibraryFileIndexS) Then
         Open LibraryFileIndexS For Binary As #1
         ReDim LCS(Lof(1) / SizeOf(LocalCodeType)-1)
         Get #1, , LCS()
         Close #1
    Else
         ReDim LCS(0)
    End If
End Sub

Sub ShowIndexContent
    Local i As Long, fName$
    fName$ = "tempfiles\index.txt"
    Open fName$ For Output As #1
    For i = 0 To UBound(LC)
         Print #1, LC(i).fname + LC(i).type + LC(i).date + Str$(LC(i).startline) + Str$(LC(i).stopline) + Str$(LC(i).startpos) + Str$(LC(i).stoppos) + LC(i).fParent
    Next i
    Close #1
    i = Shell("Notepad " + fName$, 1)
End Sub

Sub AddSearchTermToComboBox
    Local temp$, i, Flag, iCount As Long
    ComboBox Get Count hDlg, %IDC_ComboBox To iCount
    Control Get Text hDlg, %IDC_ComboBox To SearchTerm
    For i = 1 To iCount
         ComboBox Get Text hDlg, %IDC_ComboBox, i To temp$
         If IIf$(CaseSensitive,temp$,LCase$(temp$)) = IIf$(CaseSensitive,SearchTerm,LCase$(SearchTerm)) Then Flag = i : Exit For
    Next i
    ComboBox Delete hDlg, %IDC_ComboBox, IIf(Flag, Flag, iCount)
    ComboBox Insert hDlg, %IDC_ComboBox, 1, SearchTerm
    ComboBox Select hDlg, %IDC_ComboBox, 1
End Sub

Function GetSpecifiedProcedure(iPos As Long) As String 'iPos is position in LC() containing coordinates of procedure
    If SortInWork Then Exit Function
    If UBound(LC) = -1 Then Exit Function
    If iPos < 1 Or iPos > UBound(LC) Then Exit Function


    Local length As Long
    If Len(fileBuf)=0 Then
       Open LibraryFileName For Binary As #1
       Get$ #1, Lof(1), filebuf
       Close #1
    End If

    length =LC(iPos).stoppos - LC(iPos).startpos + 1
    If length<0 Then length=-length
    Function = Peek$( StrPtr(fileBuf)+LC(iPos).startpos-1, length )
End Function

Sub CreateButtonTooltips
    Local hToolTip, hTooltipL As Dword
    hToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
         0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
    SetToolTip(hToolTip, hBtnFind, "Search Context of Procedures")

    hToolTipL = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
         0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
    SetToolTip(hToolTipL, hBtnFindL, "Search Procedure Names Only (Default)")
End Sub

Sub SetToolTip(hTooltip As Dword, hControl As Dword, TipText As WStringZ*50)
    Local TI As TOOLINFO
    TI.cbSize    = SizeOf(TI)
    TI.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
    TI.hWnd      = GetParent(hToolTip)
    TI.uId       = hControl
    TI.lpszText  = VarPtr(TipText)
    SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub SetHeaderIcons(ByVal iActiveColumn As Integer, hHeader As Dword)
    Local i As Integer, hdi As HD_ITEM
    For i = 0 To Header_GetItemCount(hHeader) - 1
         hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
         hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
         If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 6
         Header_SetItem(hHeader, i, hdi)
    Next
End Sub

Sub ShowSummaryReport
    Local temp$
    temp$ += "Procedure Count: " + $Tab + Format$(UBound(LC),"###,##0") + $CrLf
    temp$ += "File Count: " + $Tab +  Format$(FileCount+1,"###,##0") + $CrLf
    temp$ += "Lines: " + $Tab + $Tab + Format$(LC(UBound(LC)).stopline - FileCount - 1, "##,###,##0") + $CrLf + $CrLf
    temp$ += "Procedures in Results: " + $Tab + Format$(UBound(LCS),"###,##0") + $CrLf + $CrLf
    temp$ += StartFolder + $CrLf + $CrLf
    temp$ += PathIDE + $CrLf
    temp$ += PathHelpPB + $CrLf + $CrLf
    temp$ += PathTextEditor + $CrLf
    MsgBox temp$, %MB_Ok + %MB_TaskModal + %MB_IconInformation, "Procedure Library Summary"
End Sub

Sub UpdateStatusBar
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, _
         "   Procedures: " + Format$(UBound(LC),"###,##0") + _
         "   Files: " + Format$(FileCount+1,"###,##0") + _
         "   Lines: " + Format$(LC(UBound(LC)).stopline - UBound(Files) - 1,"###,##0") + _
         "   Time: " + Format$((qStop-qStart)/qFreq,"###.000") & "s"
End Sub

Sub DisplayWaitDialog
    Dialog Default Font "Tahoma", 14,1
    Dialog New Pixels, hDlg, "Cancel Library Build", 20,70,250,110, %WS_Popup Or %WS_Border To hWait
    Dialog Set Icon hWait, "aaa"
    Dialog Set Color hWait, %Black, %Yellow
    Control Add Label, hWait, %IDC_WaitLabel, "Please wait ... cancelling library build!", 0,20,250,50, %SS_Center
    Control Set Color hWait, %IDC_WaitLabel, %Black, %Yellow
    Dialog Show Modeless hWait
End Sub

Sub GetFilesAndFolders
    Local iPos As Long, tempDIR As DirData, temp$
    ReDim Folders(250000), Files(250000)
    FileCount = -1 : FolderCount = 0 : iPos = 0
    Folders(iPos).FileName = RTrim$(StartFolder,"\")     'no ending \
    Do While Len(Folders(iPos).FileName)
         temp$ = Dir$(Folders(iPos).FileName + "\*.*", %Normal + %SubDir, To tempDir)
         Do While Len(temp$)
             tempDir.FileName = Folders(iPos).FileName + "\" + tempDir.FileName
             If (tempDir.FileAttributes And %File_Attribute_Directory) = 0 Then  'files
                  Incr TotalFileCount
                  If PathMatchSpec((tempDir.Filename), (FileExt)) Then
                      Incr FileCount
                      Files(FileCount) = tempDir
                  End If
             Else                                                                'folder
                  Incr FolderCount
                  Folders(FolderCount) = tempDir
             End If
             temp$ = Dir$(Next, To tempDir)
         Loop
         Incr iPos
    Loop
    If FileCount > -1 Then ReDim Preserve Files(FileCount) Else ReDim Files(0)
    ReDim Preserve Folders(FolderCount)
End Sub
Function Get4( tmp$, ByRef w1$, ByRef w2$, ByRef w3$, ByRef w4$ ) As Long
   Dim bp As Byte Ptr
   Dim i As Long

   bp = StrPtr(tmp$)
   While @bp<=32 And @bp>0
      Incr bp
   Wend
   i=0
   While @bp[i]>32
      Incr i
   Wend
   w1$ = Peek$( bp, i )
   ' If we don't have one of the starting (or ending) sequences, let's bail.  No sense working extra hard
   If InStr("sub/fun/fas/cal/thr/enu/uni/mac/typ/cla/ove/pro/met/int/end", LCase$(Left$(w1$,3)))=0 Then Function = 0: Exit Function
   bp += i

   While @bp<=32 And @bp>0
      Incr bp
   Wend
   i=0
   While @bp[i]>32
      Incr i
   Wend
   w2$ = Peek$( bp, i )
   bp += i

   While @bp<=32 And @bp>0
      Incr bp
   Wend
   i=0
   While @bp[i]>32
      Incr i
   Wend
   w3$ = Peek$( bp, i )
   bp += i

   While @bp<=32 And @bp>0
      Incr bp
   Wend
   i=0
   While @bp[i]>32
      Incr i
   Wend
   w4$ = Peek$( bp, i )
   Function = 1
End Function

Sub SearchList
    Local i, mCount As Long, sTerm$
    MousePtr 11
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Searching list ... please wait ..."
    'get needed information
    ReDim LCS(UBound(LC))
    ListView Reset hDlg, %IDC_ListViewS
    Control Get Text hDlg, %IDC_ComboBox To SearchTerm
    If CaseSensitive Then sTerm$ = SearchTerm Else sTerm$ = LCase$(SearchTerm)

    'cycle thru LC() procedure names only (not the whole procedure code)
    For i = 1 To UBound(LC)
         If InStr(  IIf$(CaseSensitive, LC(i).fName, LCase$(LC(i).fName)), sTerm$) Then
             Incr mCount
             LCS(mCount) = LC(i)
             LCS(mCount).lcPos = i
         End If
    Next i
    ReDim Preserve LCS(mCount)
    ListView_SetItemCountEx(hListViewS, mCount, %LVSICF_noInvalidateAll) 'max rows
    Control ReDraw hDlg, %IDC_ListViewS
    ListView Select hDlg, %IDC_ListViewS, 1
    ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Matching Procedures: " + Str$(mCount)
    MousePtr 1
End Sub

Sub ShowUnique
    Local i, mCount As Long
    MousePtr 11
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Searching list ... please wait ..."
    'get needed information
    ReDim LCS(UBound(LC))
    ListView Reset hDlg, %IDC_ListViewS

    'cycle thru LC() procedure names only (not the whole procedure code)
    For i = 1 To UBound(LC)
         If LC(i).md5 <> LC(i-1).md5 Then
             Incr mCount
             LCS(mCount) = LC(i)
             LCS(mCount).lcPos = i
         End If
    Next i
    ReDim Preserve LCS(mCount)
    ListView_SetItemCountEx(hListViewS, mCount, %LVSICF_noInvalidateAll) 'max rows
    Control ReDraw hDlg, %IDC_ListViewS
    ListView Select hDlg, %IDC_ListViewS, 1
    ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Unique Procedures: " + Str$(mCount)
    MousePtr 1
End Sub

Sub ShowBookmarks
    Local i, mCount As Long
    MousePtr 11
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Searching list ... please wait ..."
    'get needed information
    ReDim LCS(UBound(LC))
    ListView Reset hDlg, %IDC_ListViewS

    'cycle thru LC() procedure names only (not the whole procedure code)
    For i = 1 To UBound(LC)
         If LC(i).Bookmark Then
             Incr mCount
             LCS(mCount) = LC(i)
             LCS(mCount).lcPos = i
         End If
    Next i
    ReDim Preserve LCS(mCount)
    ListView_SetItemCountEx(hListViewS, mCount, %LVSICF_noInvalidateAll) 'max rows
    Control ReDraw hDlg, %IDC_ListViewS
    ListView Select hDlg, %IDC_ListViewS, 1
    ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Bookmarked Procedures: " + Str$(mCount)
    MousePtr 1
End Sub

Sub SearchSnippets
    Local i,mCount As Long, temp$, sTerm$
    MousePtr 11
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Searching procedure content ... please wait ..."
    'get needed information
    ReDim LCS(UBound(LC))
    ListView Reset hDlg, %IDC_ListViewS
    Control Get Text hDlg, %IDC_ComboBox To SearchTerm
    If CaseSensitive Then sTerm$ = SearchTerm Else sTerm$ = LCase$(SearchTerm)

    'cycle thru LC() procedure text only
    For i = 1 To UBound(LC)
         temp$ = GetSpecifiedProcedure(i)
         If InStr( IIf$(CaseSensitive,temp$,LCase$(temp$)),sTerm$) Then
             Incr mCount
             LCS(mCount) = LC(i)
             LCS(mCount).lcPos = i
         End If
    Next i
    ReDim Preserve LCS(mCount)
    ListView_SetItemCountEx(hListViewS, mCount, %LVSICF_noInvalidateAll) 'max rows
    Control ReDraw hDlg, %IDC_ListViewS
    ListView Select hDlg, %IDC_ListViewS, 1
    ListView_SetItemState hListViewS, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Matching Procedures: " + Str$(mCount)
    MousePtr 1
End Sub

'Ascending Sorts--------------------------
Function SortByFNameA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.fname) < LCase$(B.fname) Then Function = -1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = +1 : Exit Function
    If A.md5  < B.md5  Then Function = -1 : Exit Function
    If A.md5  > B.md5  Then Function = +1 : Exit Function
    If LCase$(A.date)  < LCase$(B.date)  Then Function = -1 : Exit Function
    If LCase$(A.date)  > LCase$(B.date)  Then Function = +1 : Exit Function
End Function

Function SortByDateA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.date)  < LCase$(B.date)  Then Function = -1 : Exit Function
    If LCase$(A.date)  > LCase$(B.date)  Then Function = +1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = -1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = +1 : Exit Function
End Function

Function SortByTypeA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.type)  < LCase$(B.type)  Then Function = -1 : Exit Function
    If LCase$(A.type)  > LCase$(B.type)  Then Function = +1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = -1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = +1 : Exit Function
End Function

Function SortByFSpecA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.fparent) < LCase$(B.fparent) Then Function = -1 : Exit Function
    If LCase$(A.fparent) > LCase$(B.fparent) Then Function = +1 : Exit Function
    If LCase$(A.date)    < LCase$(B.date)    Then Function = -1 : Exit Function
    If LCase$(A.date)    > LCase$(B.date)    Then Function = +1 : Exit Function
End Function

Function SortByLinesA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.lines < B.lines Then Function = -1 : Exit Function
    If A.lines > B.lines Then Function = +1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = -1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = +1 : Exit Function
End Function

Function SortByStartLineA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.StartLine < B.StartLine Then Function = -1 : Exit Function
    If A.StartLine > B.StartLine Then Function = +1 : Exit Function
End Function

Function SortByStartPosA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.StartPos < B.StartPos Then Function = -1 : Exit Function
    If A.StartPos > B.StartPos Then Function = +1 : Exit Function
End Function

Function SortByParentLineA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.ParentLine < B.ParentLine Then Function = -1 : Exit Function
    If A.ParentLine > B.ParentLine Then Function = +1 : Exit Function
End Function

Function SortByCRCA(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.md5 < B.md5 Then Function = -1 : Exit Function
    If A.md5 > B.md5 Then Function = +1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = -1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = +1 : Exit Function
End Function

'Descending Sorts--------------------------
Function SortByFNameD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date descending
    If LCase$(A.fname) < LCase$(B.fname) Then Function = +1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = -1 : Exit Function
    If A.md5  < B.md5  Then Function = +1 : Exit Function
    If A.md5  > B.md5  Then Function = -1 : Exit Function
    If LCase$(A.date)  < LCase$(B.date)  Then Function = +1 : Exit Function
    If LCase$(A.date)  > LCase$(B.date)  Then Function = -1 : Exit Function
End Function

Function SortByDateD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.date)  < LCase$(B.date)  Then Function = +1 : Exit Function
    If LCase$(A.date)  > LCase$(B.date)  Then Function = -1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = +1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = -1 : Exit Function
End Function

Function SortByTypeD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If LCase$(A.type)  < LCase$(B.type)  Then Function = +1 : Exit Function
    If LCase$(A.type)  > LCase$(B.type)  Then Function = -1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = +1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = -1 : Exit Function
End Function

Function SortByFSpecD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date descending
    If LCase$(A.fparent) < LCase$(B.fparent) Then Function = +1 : Exit Function
    If LCase$(A.fparent) > LCase$(B.fparent) Then Function = -1 : Exit Function
    If LCase$(A.date)    < LCase$(B.date)    Then Function = +1 : Exit Function
    If LCase$(A.date)    > LCase$(B.date)    Then Function = -1 : Exit Function
End Function

Function SortByLinesD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.lines < B.lines Then Function = +1 : Exit Function
    If A.lines > B.lines Then Function = -1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = +1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = -1 : Exit Function
End Function

Function SortByStartLineD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.StartLine < B.StartLine Then Function = +1 : Exit Function
    If A.StartLine > B.StartLine Then Function = -1 : Exit Function
End Function

Function SortByStartPosD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.StartPos < B.StartPos Then Function = +1 : Exit Function
    If A.StartPos > B.StartPos Then Function = -1 : Exit Function
End Function

Function SortByParentLineD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.ParentLine < B.ParentLine Then Function = +1 : Exit Function
    If A.ParentLine > B.ParentLine Then Function = -1 : Exit Function
End Function

Function SortByCRCD(A As LocalCodeType, B As LocalCodeType) As Long   'forum-date ascending
    If A.md5 < B.md5 Then Function = +1 : Exit Function
    If A.md5 > B.md5 Then Function = -1 : Exit Function
    If LCase$(A.fname) < LCase$(B.fname) Then Function = +1 : Exit Function
    If LCase$(A.fname) > LCase$(B.fname) Then Function = -1 : Exit Function
End Function

Sub ManageViewFiles(task$)
    If task$ = "save" Then
         Open $RightViewFile For Output As #1 : Print #1, RightView; : Close #1
    End If

    If Task$ = "get" Then
         If IsFile($RightViewFile) Then
             Open $RightViewFile For Binary As #1
             Get$ #1, Lof(1), RightView
             Close #1
         Else
             RightView = "<empty>"
         End If
    End If
End Sub

Sub SaveAsFile
      'save file to any location
      Local title$, sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
      title$ = ""                            'caption title. if "", then "Save As" is displayed
      sfolder$ = PathName$(Path,ExternalFileName)    'initial folder to be displayed
      filter$ = "gbVisualDesigner Source Code (*.*)" + $Nul + "*.bas" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      startfile$ = ExternalFileName                  'name to be used as initial selection
      defaultext$ = "bas"        'default extension to append to selection if user does not enter it
      flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
      Display Savefile hDlg, 100, 100, title$, sfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then
          ExternalFileName = filevar$
          Open filevar$ For Output As #1
          Print #1, temp$;
          Close #1
          Statusbar Set Text hDlg, %IDC_Statusbar, 2,0, "Code saved as:  " + ExternalFileName
      End If
End Sub

Sub OpenExternalFile
      Local sfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&, temp$
      filter$ = "Source Code Files" + $Nul + "*.bas;*.inc" + $Nul   ' or filter$ = CHR$("Text",0,"*.txt",0)
      sfolder$ = PathName$(Path,ExternalFileName)    'initial folder to be displayed
      startfile$ = ExternalFileName                  'name to be used as initial selection
      flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
      Display Openfile hDlg, 100, 100, "", sfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
      If Len(filevar$) Then
          ExternalFileName = filevar$
          Open ExternalFileName For Binary As #1
          Get$ #1, Lof(1), temp$
          Close #1
          Sci_SetText(GetFocus, temp$)
          Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "Code loaded from ... " + ExternalFileName
    End If
End Sub
Function GetHTMLText_All(fName$) As String
    Local  temp$, pDoc As IHTMLDocument2
    pDoc = NewCom ClsId $CLSID_HTMLDocument
    Open fName$ For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
    IHTMLDocument2_WriteString(pDoc, temp$)
    pDoc.Close
    Function  = pDoc.body.innerText
End Function

Function GetMD5(ByVal strText As String) As String
    Register i As Long
    Local hHash As Dword, hText As String

    CryptCreateHash( hProv, %CALG_MD5, 0, 0, hHash )
    CryptHashData( hHash, ByVal StrPtr(strText), Len(strText), 0 )
    CryptGetHashParamX( hHash, %HP_HASHVAL, strHashPtr, 16, 0 )
    CryptDestroyHash hHash

    For i = 0 To 15
         hText += Hex$( @strHashPtr[i], 2 )
      Next
    Function = hText
End Function


Function GetCSPHandle(hCSP As Dword) As Long
   If CryptAcquireContext( hCSP, ByVal %Null, ByVal %Null, %PROV_RSA_AES, 0 ) = %False Then
      ' Unable To Find a Default For %PROV_RSA_AES so force the issue first For Vista And above
      If CryptAcquireContext( hCSP, ByVal %Null, $MS_ENH_RSA_AES_PROV_A, %PROV_RSA_AES, %CRYPT_VERIFYCONTEXT ) = %False Then
         ' Still failed so force the issue With XP SP3
         If CryptAcquireContext( hCSP, ByVal %Null, $MS_ENH_RSA_AES_PROV_XP_A, %PROV_RSA_AES, %CRYPT_VERIFYCONTEXT ) = %False Then
            ' Stll failed so Try And Find a Default For < XP SP3
            If CryptAcquireContext( hCSP, ByVal %Null, ByVal %Null, %PROV_RSA_FULL, 0 ) = %FALSE Then
               ' Unable To Find a Default For %PROV_RSA_FULL failed so force the issue
               If CryptAcquireContext( hCSP, ByVal %Null,$MS_DEF_PROV_A, %PROV_RSA_FULL, %CRYPT_VERIFYCONTEXT ) = %FALSE Then
                  Function = 0
               Else
                  Function = 1 ' < XP SP3
               End If
            Else ' found Default %PROV_RSA_FULL
               Function = 1
            End If
         Else
            Function = 2 ' XP SP3
         End If
      Else
         Function = 3 ' Vista And above
      End If
   Else ' found Default %PROV_RSA_AES
      Function = 3
   End If
End Function

Macro IndentD = D(i) = Space$(iLevel*IndentSize) + D(i)
Macro IndentD1 = D(i) = Space$((iLevel+1)*IndentSize) + D(i)
Macro IG   = D(i) = Space$(iLevel*IndentSize) + D(i) : GoTo Finish
Macro IIG  = D(i) = Space$(iLevel*IndentSize) + D(i) : Incr iLevel : GoTo Finish
Macro DIIG = Decr iLevel : D(i) = Space$(iLevel*IndentSize) + D(i) : Incr iLevel : GoTo Finish
Macro DIG  = Decr iLevel : D(i) = Space$(iLevel*IndentSize) + D(i) : GoTo Finish
Macro ZG   = iLevel = 0 : GoTo Finish
Macro FG   = fFlag = 1 : GoTo Finish
Macro IIFG  = D(i) = Space$(iLevel*IndentSize) + D(i) : fFlag = 1 : Incr iLevel : GoTo Finish
Macro IFG  = D(i) = Space$(iLevel*IndentSize) + D(i) : fFlag = 1 : GoTo Finish
Macro DFG  = Decr iLevel : fFlag = 1 : GoTo Finish
Macro ZFG  = iLevel = 0 : fFlag = 1 : GoTo Finish
Macro OFG  = iLevel = 1 : fFlag = 1 : GoTo Finish

Function SCILeftJustify(hScintilla As Dword) As String
    Local temp$, i, SelLength As Long

    SciSelectWholeLines(hScintilla)                        'format only entire lines
    temp$ = Sci_GetSelText(hScintilla)                     'get selected text
    SelLength = Len(temp$)
    If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla)
    If Len(temp$) = 0 Then Exit Function

    'put into an array
    Dim tempArray(ParseCount(temp$, $CrLf)-1) As String
    Parse temp$, tempArray(), $CrLf

    'LTrim$ all
    For i = 0 To UBound(tempArray)
         tempArray(i) = LTrim$(tempArray(i))
    Next i

    'set scintilla text
    If SelLength Then
         Sci_ReplaceSel hScintilla, Join$(tempArray(), $CrLf)
    Else
         Sci_SetText hScintilla, Join$(tempArray(), $CrLf)
    End If
End Function

Function SCIRemoveBlanks(hScintilla As Dword) As String
    Local temp$, i, iCount, SelLength As Long

    SciSelectWholeLines(hScintilla)                        'format only entire lines
    temp$ = Sci_GetSelText(hScintilla)                     'get selected text
    SelLength = Len(temp$)
    If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla)
    If Len(temp$) = 0 Then Exit Function

    'put into an array
    Dim tempArray(ParseCount(temp$, $CrLf)-1) As String
    Parse temp$, tempArray(), $CrLf
    Dim tempArrayB(UBound(tempArray)) As String

    'LTrim$ all
    iCount = -1
    For i = 0 To UBound(tempArray)
         If Len(Trim$(tempArray(i))) Then
             Incr iCount
             tempArrayB(iCount) = tempArray(i)
         End If
    Next i

    'set scintilla text
    If iCount = -1 Then Exit Function             'no change to text
    If SelLength Then
         Sci_ReplaceSel hScintilla, Join$(tempArrayB(), $CrLf)
    Else
         Sci_SetText hScintilla, Join$(tempArrayB(), $CrLf)
    End If
End Function

Sub SciSelectWholeLines(hScintilla As Dword)
    Local i,j As Long
    i = SendMessage(hScintilla,%SCI_GetSelectionStart,0,0)      'start of selection
    j = SendMessage(hScintilla,%SCI_GetSelectionEnd,0,0)        'end of selection
    If i = j Then Exit Sub                                      'no selection
    i = SendMessage(hScintilla, %SCI_LineFromPosition,i,0)      'line containing start of selection
    j = SendMessage(hScintilla, %SCI_LineFromPosition,j,0)      'line containing end of selection
    i = SendMessage(hScintilla, %SCI_PositionFromLine, i,0)     '1st char in line containing start of selection
    j = SendMessage(hScintilla, %SCI_GetLineEndPosition, j,0)   'Last char in line containing end of selection
    SendMessage hScintilla, %SCI_SetSel, i,j
End Sub


Function SCIFormat(hScintilla As Dword) As String
    Local lctemp$,temp$,iPos,bCount,i,j, SelLength As Long
    Local cFlag, sFlag, dFlag, fFlag, iLevel As Long, lcD(), tempD(), D() As String


    SciSelectWholeLines(hScintilla)                        'format only entire lines
    temp$ = Sci_GetSelText(hScintilla)                     'get selected text
    SelLength = Len(temp$)
    If Len(temp$) = 0 Then temp$ = Sci_GetText(hScintilla) 'if no selected text, format entire document
    If Len(temp$) = 0 Then Exit Function                   'if no text, do nothing and exit

    Replace $Tab With Space$(IndentSize) In temp$
    lctemp$ = LCase$(temp$)

    i = ParseCount(temp$, $CrLf)
    ReDim D(i-1), lcD(i-1), tempD(4*i)
    Parse temp$,     D(), $CrLf
    Parse lctemp$, lcD(), $CrLf

    'test start of each line to know how much to indent
    iPos = -1
    Dialog Set Text hDlg, "gbCodeIndent   " + $Ver + "   ... formatting ... please wait!"
    For i = 0 To UBound(D)
'      If (i Mod 500) = 0 Then
'         Dialog Set Text hDlg, "gbCodeIndent   " + $Ver + "       Line: " + Str$(i) + "   Complete: " + Format$(100*i/UBound(D),"##") + "%"
'      End If

         D(i) = Trim$(D(i), Any $Spc + $Tab)
         If Len(D(i)) = 0 And ManageBlankLines Then Incr bCount : Iterate For
         If Len(D(i)) = 0 Then GoTo Finish
         temp$ = Trim$(TrimComments(lcD(i)))
         If cFlag Then IndentD1 : GoTo Finish     'previous line ended in _ so use this line as is, with indentation to iLevel, iLevel remains unchanged
         If Right$(temp$,1)  = ":" And Verify(temp$,Chr$(97 To 122, 48 To 58, 95)) = 0 Then  GoTo Finish    'labels  no indentation, lower case, numbers, underline

'zero indentation constructs ==============================================================================================================================
         'single line, multi-statement constructs (No children)
         If Left$(temp$,6)  = "macro " And InStr(temp$,"=")                     Then IG  ' Macro myMacro = x=2
         If Left$(temp$,5)  = "type " And Right$(temp$,8) = "end type"          Then IG  ' Type x : ... : End Type
         If Left$(temp$,6)  = "union " And Right$(temp$,9) = "end union"        Then IG  ' Union x : ... : End Union
         If Left$(temp$,4)  = "sub " And Right$(temp$,7) = "end sub"            Then IG  ' Sub x : ... : End Sub
         If Left$(temp$,9)  = "function " And Right$(temp$,12) = "end function" Then IG  ' Function x : ... : End Function
         If Left$(temp$,9)  = "callback " And Right$(temp$,12) = "end function" Then IG  ' Callback Function x : ... : End Function
         If Left$(temp$,7)  = "thread " And Right$(temp$,12) = "end function"   Then IG  ' Thread Function x : ... : End Function

         If Left$(temp$,9)  = "fastproc " And Right$(temp$,12) = "end fastproc" Then IG  ' FastProc x : ... : End FastProc
         If Left$(temp$,8)  = "asmdata " And Right$(temp$,11) = "end asmdata"   Then IG  ' ASMData x : ... : End ASMData

         'multi-line constructs (Children)
         If Left$(temp$,6)  = "macro "                                          Then IIFG
         If Left$(temp$,9)  = "end macro"                                       Then DIG
         If Left$(temp$,5)  = "type " And Left$(temp$,8) <> "type set"          Then IIFG
         If Left$(temp$,8)  = "end type"                                        Then DIG
         If Left$(temp$,6)  = "union "                                          Then IIFG
         If Left$(temp$,9)  = "end union"                                       Then DIG
         If Left$(temp$,4)  = "sub "                                            Then IIFG
         If Left$(temp$,7)  = "end sub"                                         Then DIG
         If Left$(temp$,9)  = "function " And Left$(temp$,10) <> "function ="   Then IIFG
         If Left$(temp$,9)  = "callback "                                       Then IIFG
         If Left$(temp$,16) = "thread function "                                Then IIFG
         If Left$(temp$,12) = "end function"                                    Then DIG

         If Left$(temp$,5)  = "enum "                                          Then IIFG
         If Left$(temp$,8)  = "end enum"                                       Then DIG
         If Left$(temp$,7)  = "prefix "                                        Then IIFG
         If Left$(temp$,10) = "end prefix"                                     Then DIG
         If Left$(temp$,8)  = "asmdata "                                       Then IIFG
         If Left$(temp$,11) = "end asmdata"                                    Then DIG
         If Left$(temp$,9)  = "fastproc "                                      Then IIFG
         If Left$(temp$,12) = "end fastproc"                                   Then DIG

'n-level indentation constructs ===========================================================================================================================
         'single line, multi-statement constructs (No children)
         If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"then ") And Len(Mid$(temp$,InStr(-1,temp$,"then ")+5)) > 0             Then IG  ' If x then y=2
         If Left$(temp$,3)  = "if "  And InStr(-1,temp$,"else ") And Len(Mid$(temp$,InStr(-1,temp$,"else ")+5)) > 0             Then IG  ' If x then y=2 else z=4

         If Left$(temp$,4)  = "for " And InStr(-1,temp$,"next ") And Len(Mid$(temp$,InStr(-1,temp$,"next ")+5)) > 0             Then IG  ' For x=2 To 5 : next i

         If Left$(temp$,3)  = "do " And Right$(temp$,4) = "loop"                                                                Then IG  ' Do Until/While : ... : Loop
         If Left$(temp$,3)  = "do:" And Right$(temp$,4) = "loop"                                                                Then IG  ' Do: ... : Loop

         If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 0 Then IG  ' Do .. : .. : Loop While x=2
         If Left$(temp$,3)  = "do " And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 0 Then IG  ' Do .. : .. : Loop Until x=2
         If Left$(temp$,3)  = "do:" And InStr(-1,temp$,"loop while ") And Len(Mid$(temp$,InStr(-1,temp$,"loop while ")+11)) > 0 Then IG  ' Do: .. : Loop While x=2
         If Left$(temp$,3)  = "do:" And InStr(-1,temp$,"loop until ") And Len(Mid$(temp$,InStr(-1,temp$,"loop until ")+11)) > 0 Then IG  ' Do: .. : Loop Until x=2

         If Left$(temp$,6)  = "while " And Right$(temp$,4) = "wend"                                                             Then IG  ' While x=2 : y=3 : Wend
         If Left$(temp$,4)  = "try " And Right$(temp$,7) = "end try"                                                            Then IG  ' Try : ... : ... : End Try
         If Left$(temp$,4)  = "try:" And Right$(temp$,7) = "end try"                                                            Then IG  ' Try: ... : ... : End Try

         'multi-line constructs (Children)
         If Left$(temp$,3)  = "if "                 Then IIG
         If Left$(temp$,7)  = "elseif "             Then DIIG
         If Left$(temp$,5)  = "else "               Then DIIG
         If Left$(temp$,5)  = "else:"               Then DIIG
         If temp$ = "else"                          Then DIIG
         If Left$(temp$,6)  = "end if"              Then DIG

         If Left$(temp$,4)  = "#if "                Then dFlag = 1 : IIG
         If Left$(temp$,8)  = "#elseif "            Then DIIG
         If temp$ = "#else"                         Then DIIG
         If temp$ = "#endif"                        Then dFlag = 0 : DIG

         If Left$(temp$,4)  = "for "                Then IIG    ' For i = 1 to 10    (space after For)
         If Left$(temp$,5)  = "next "               Then DIG    ' Next i
         If Left$(temp$,5)  = "next:"               Then DIG    ' Next:
         If temp$ = "next"                          Then DIG    ' Next    (nothing behind it)

         If Left$(temp$,3)  = "do "                 Then IIG
         If Left$(temp$,3)  = "do:"                 Then IIG
         If temp$ = "do"                            Then IIG
         If Left$(temp$,5)  = "loop "               Then DIG
         If Left$(temp$,5)  = "loop:"               Then DIG
         If temp$ = "loop"                          Then DIG
         If Right$(temp$,5) = " loop" And Right$(temp$,9) <> "exit loop"  Then DIG
         If Right$(temp$,5) = ":loop"               Then DIG

         If Left$(temp$,6)  = "while "              Then IIG
         If Left$(temp$,5)  = "wend "               Then DIG
         If Left$(temp$,5)  = "wend:"               Then DIG
         If temp$ = "wend"                          Then DIG

         If Left$(temp$,7)  = "select "             Then sFlag = 1 : IIG
         If sFlag Then
               If Left$(temp$,5)  = "case "               Then sFlag = 0 : IIG
               If Left$(temp$,5)  = "case:"               Then sFlag = 0 : IIG
               If temp$ = "case"                          Then sFlag = 0 : IIG
               If Left$(temp$,10)  = "case else "         Then sFlag = 0 : IIG
               If Left$(temp$,10)  = "case else:"         Then sFlag = 0 : IIG
         Else
               If Left$(temp$,5)  = "case "               Then sFlag = 0 : DIIG
               If Left$(temp$,5)  = "case:"               Then sFlag = 0 : DIIG
               If temp$ = "case"                          Then sFlag = 0 : DIIG
               If Left$(temp$,10)  = "case else "         Then sFlag = 0 : DIIG
               If Left$(temp$,10)  = "case else:"         Then sFlag = 0 : DIIG
               If temp$ = "case else"                     Then sFlag = 0 : DIIG
         End If
         If Left$(temp$,10) = "end select"          Then sFlag = 0 : Decr iLevel : DIG

         If Left$(temp$,4) = "try "                 Then IIG
         If Left$(temp$,4) = "try:"                 Then IIG
         If temp$ = "try"                           Then IIG

         If Left$(temp$,6) = "catch "               Then DIIG
         If Left$(temp$,6) = "catch:"               Then DIIG
         If temp$ = "catch"                         Then DIIG

         If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try "   Then DIG
         If Left$(temp$,8) = "finally " And Right$(temp$,8) = "end try:"   Then DIG
         If Left$(temp$,8) = "finally " And Right$(temp$,7) = "end try"    Then DIG

         If Left$(temp$,8) = "finally:" And Right$(temp$,8) = "end try "   Then DIG
         If Left$(temp$,8) = "finally:" And Right$(temp$,8) = "end try:"   Then DIG
         If Left$(temp$,8) = "finally:" And Right$(temp$,7) = "end try"    Then DIG

         If Left$(temp$,8) = "finally "             Then DIIG
         If Left$(temp$,8) = "finally:"             Then DIIG
         If temp$ = "finally"                       Then DIIG

         If Left$(temp$,8) = "end try "             Then DIG    ' End Try :  (statement following on same line)
         If Left$(temp$,8) = "end try:"             Then DIG    ' End Try:   (statement following on same line)
         If temp$ = "end try"                       Then DIG    ' End Try    (alone)

'objects ==============================================================================================================================

         If Left$(temp$,13) = "class method "         Then IIG
         If Left$(temp$,16) = "override method "      Then IIG

         If Left$(temp$,6)  = "class "     And Left$(temp$,10) <> "function ="      Then IIFG
         If Left$(temp$,9)  = "end class"                                           Then DIG

         If Left$(temp$,10) = "interface " And Right$(temp$,13) = "end interface"   Then IG  ' Interface : ... : End Interface
         If Left$(temp$,7)  = "method "    And Right$(temp$,10) = "end method"      Then IG  ' Method    : ... : End Method
         If Left$(temp$,9)  = "property "  And Right$(temp$,12) = "end property"    Then IG  ' Property  : ... : End Property

         If Left$(temp$,10) = "interface "            Then IIG
         If Left$(temp$,13) = "end interface"         Then DIG

         If Left$(temp$,9)  = "property " And Left$(temp$,10) <> "property ="   Then IIG
         If Left$(temp$,12) = "end property"          Then DIG

         If Left$(temp$,7)  = "method "               Then IIG
         If Left$(temp$,10) = "end method"            Then DIG

'all other lines =====================================================================================================================
         D(i) = Space$(iLevel*IndentSize) + D(i)

Finish:
         If Right$(temp$,1) = "_" Then cFlag = 1 Else cFlag = 0
         If fFlag And ManageBlankLines Then
             For j = 1 To procB : Incr iPos : Next j
         Else
             For j = 1 To Min(bCount,maxB) : Incr iPos : Next j
         End If
         Incr iPos : tempD(iPos) = D(i) : bCount = 0 : fFlag = 0
    Next i
    ReDim Preserve tempD(iPos)

    'set scintilla text
    If SelLength Then
         Sci_ReplaceSel hScintilla, Join$(tempD(), $CrLf)
    Else
         Sci_SetText hScintilla, Join$(tempD(), $CrLf)
    End If
End Function

Function TrimComments(temp$) As String
    Local i, qFlag As Long, c As String
    For i = 1 To Len(temp$)
         c = Mid$(temp$,i,1)
         If c = $Dq And qFlag = 1 Then
             qFlag = 0
         ElseIf c = $Dq Then
             qFlag = 1
       ElseIf c = "'" And qFlag = 0 Then
             Function = RTrim$(Left$(temp$,i-1))   'found single-quote character not embedded in double-quotes
             Exit Function
         End If
    Next i
    Function = temp$
End Function


Sub BuildFakeFile
    'build the fake file
    Open $FakeFile For Output As #77
    Print #77, "Sub No_Procedures_Found"
    Print #77, "End Sub";
    Close #77
    'put the file info into Files() and Folders()
    FileCount = 0
    Folders(0).filename = Exe.Path$ + "tempfiles\"
    Files(0).filename = Exe.Path$ + $FakeFile
End Sub

Sub BuildFakeLibrary
    'put the file info into Files() and Folders()
    Folders(0).filename = Exe.Path$ + "tempfiles\"
    Files(0).filename = Exe.Path$ + $FakeFile
    'put the fie info into LC()
    LC(1).fName = "No_Procedures_Found"
    LC(1).fParent = Exe.Path$ + $FakeFile
    LC(1).startline = 2
    LC(1).stopline = 3
    LC(1).lines = 2
End Sub

Sub ManageDebug
    If Debug Then Txt.Print FuncName$
    If Debug Then
         Txt.Window "Debug", 300,300,40,40 To hDebug
         Txt.Print "TXT Window Opened"
    Else
         Txt.End
    End If
End Sub

Thread Function BuildLocalLibrary(ByVal x As Long) As Long
    Local i,j, pCount,FirstLine, pFlag As Long
    Local temp$, lft As FileTime, st As SystemTime
    Local tmp$, w1$, w2$, w3$, r$, s1$, s2$, s3$, s12$, s2_1$
    Local w4$, s4$, s123$: ' Unused
    Local pDate, pName, pType, tempFileName, ErrReport As String
    Local FirstLine2, FirstLine3 As Long
    Local pCount2, pCount3, isAlpha As Long
    Local temp2$, bp As Byte Ptr

    Local SB As IStringBuilderA
    SB = Class "StringBuilderA"
    BuildInWork = 1
    MousePtr 11
    QueryPerformanceCounter qStart

    'get files/folders list
    If X Then
         i = SelectSingleFile
         If (i=0) Or IsFalse(IsFile(SingleFile)) Then
             Beep : MousePtr 1 : BuildInWork = 0 : Exit Function
         Else
             FileCount = 0 : FolderCount = 0
             temp$ = Dir$(SingleFile To Files(0))  'get DIRDATA info into Files(0)
             Folders(0).FileName = PathName$(Path,SingleFile)
             Files(0).FileName = SingleFile
             ReDim Preserve Files(0)
             ReDim Preserve Folders(0)
         End If
    Else
         GetFilesAndFolders
    End If

    'remove old information
    Sci_SetText hSci, ""
    Sci_SetText hSciV, ""
    ListView Reset hDlg, %IDC_ListView
    ListView Reset hDlg, %IDC_ListViewS
    Statusbar Set Text hDlg, %IDC_Statusbar, 2, 0, "Building local procedure library ... (getting files and folders)"

    'clear the output file
    ReDim LCS(0)
    ReDim LC(250000)             'position 0 of LC() is not used
    If IsFile(LibraryFileName) Then Kill LibraryFileName
    If IsFile(LibraryFileIndex) Then Kill LibraryFileIndex
    'handle no files found
    If FileCount = -1 Then BuildFakeFile
    'copy just the Procedures
    LineCount = 0
    For i = 0 To UBound(Files)
         If BuildInWork = 0 Then Exit For
         If LCase$(PathName$(Extn,Files(i).FileName)) = ".htm" Then
               GulpA = GetHTMLText_All((Files(i).FileName))  'html files
         Else
             Open Files(i).FileName For Binary As #1 : Get$ #1, Lof(1), GulpA : Close #1
         End If
         FileTimeToLocalFileTime(ByVal VarPtr(Files(i).LastWriteTime), lft)
         FileTimeToSystemTime(lft, st)
         pDate = Format$(st.wYear,"####") + "-" + Format$(st.wMonth, "0#")+"-"+Format$(st.wDay, "0#")
         Incr LineCount
         tempFileName = Files(i).FileName
         SB.add $CrLf + $DLimit + pDate + tempFileName
         j = ParseCount(GulpA, $CrLf)
         ReDim Gulp(j-1) As String   'break input string into an array
         Parse GulpA, Gulp(), $CrLf                        'Gulp() as the FileName file content
         pFlag = 0


         For j = 0 To UBound(Gulp)
             'look for starting line of Sub/Function/Class
             tmp = Gulp(j)
             If Get4( tmp$, w1$, w2$, w3$, w4$ ) Then
                ' Still have problem of Name%, using type identifiers for names, handling that once we have a name
                s1$ = LCase$(w1$) : s2$ = LCase$(w2$) : s3$ = LCase$(w3$): s4$ = LCase$(w4$)
                s12$ = Build$(s1$, s2$):   s123$ = Build$(s1$, s2$, s3$)

                ' no need to even try this stuff in here, if the line doesn't start with the right three letters!
                If GetSub Then        If s1$  = "sub" And s2$<>"as" And s2$<>""                       Then pType = "Sub"      : pName = w2$ : FirstLine=1
                If GetFunction Then   If s1$  = "function" And s2$ <> "=" And s2$<>"as" And s2$<>""   Then pType = "Function" : pName = w2$ : FirstLine=1
                If GetFastProc Then   If s1$  = "fastproc" And s2$<>"as" And s2$<>""                  Then pType = "FastProc" : pName = w2$ : FirstLine=1
                If GetCallback Then   If s12$ = "callbackfunction"                                    Then pType = "CallBack" : pName = w3$ : FirstLine=1
                If GetThread Then     If s12$ = "threadfunction"                                      Then pType = "Thread"   : pName = w3$ : FirstLine=1
                If GetEnum Then       If s1$  = "enum" And s2$<>"as" And s2$<>""                      Then pType = "Enum"     : pName = w2$ : FirstLine=1
                If GetUnion Then      If s1$  = "union" And s2$<>"as" And s2$<>""                     Then pType = "Union"    : pName = w2$ : FirstLine=1
                If GetMacro Then      If s1$  = "macro" And s2$<>"function" And s2$<>"as" And s2$<>"" Then pType = "Macro"    : pName = w2$ : FirstLine=1
                If GetMacro Then      If s12$ = "macrofunction"                                       Then pType = "Macro"    : pName = w3$ : FirstLine=1
                If GetType Then       If s1$  = "type" And s2$<>"as" And s2$<>"" And s2$ <> "set"     Then pType = "Type"     : pName = w2$ : FirstLine=1
                If GetClass Then      If s1$  = "class" And s2$ <> "method" And s2$<>"as" And s2$<>"" Then pType = "Class"    : pName = w2$ : FirstLine=1

                ' Nested inside class and possibly instance
                If GetProperty Then   If s12$  = "propertyget" And pFlag=1                            Then pType = "Property" : pName = w3$ : FirstLine2=1
                If GetProperty Then   If s12$  = "propertyset" And pFlag=1                            Then pType = "Property" : pName = w3$ : FirstLine2=1
                If GetProperty Then   If s123$ = "overridepropertyget" And pFlag=1                    Then pType = "Property" : pName = w4$ : FirstLine2=1
                If GetProperty Then   If s123$ = "overridepropertyset" And pFlag=1                    Then pType = "Property" : pName = w4$ : FirstLine2=1
                If GetMethod Then     If s1$   = "method" And s2$ <> "=" And s2$<>"as" And s2$<>"objresult" And s2$<>"" And pFlag=1 Then pType = "Method"   : pName = w2$ : FirstLine2=1
                If GetMethod Then     If s12$  = "overridemethod" And pFlag=1                         Then pType = "Method"   : pName = w2$ : FirstLine2=1
                If GetMethod Then     If s12$  = "classmethod" And pFlag=1                            Then pType = "Method"   : pName = w3$ : FirstLine2=1

                ' Nested inside class
                If GetInterface Then  If s1$   = "interface" And pFlag=1 And s2$<>"as" And s2$<>""    Then pType = "Interface": pName = w2$ : FirstLine3=1

                If FirstLine Or FirstLine2 Or FirstLine3 Then
                   Replace Any "()"+$Tab With "   " In pName: ' Handle the no space, tab -> space
                   Replace "=" With " =" In pName: ' Handle the =0
                   pName = Parse$(pName," ",1)

                   ' Remove trailing type identifiers
                   While Len(pName) And InStr("?%&!#$@:", Right$(pName,1))
                      pName = Left$( pName, Len(pName)-1 )
                   Wend
                   isAlpha = Len(pName) And (InStr("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ", Left$(pName,1))>0)

                   ' We insert nested definitions just before the end
                  If (FirstLine2 Or FirstLine3) And isAlpha Then
                      ' Move current definition down a line to make room for nested definition
                      LC(pCount+1).parentline = j
                      LC(pCount+1).startpos  = LC(pCount).startpos
                      LC(pCount+1).startline = LC(pCount).startline
                      LC(pCount+1).fname     = LC(pCount).fname
                      LC(pCount+1).fparent   = LC(pCount).fparent
                      LC(pCount+1).date      = LC(pCount).date
                      LC(pCount+1).type      = LC(pCount).type
                   End If
                   If FirstLine2  And isAlpha Then
                      ' when property or method do these things.
                        ' Unterminated method/property.  These are late catches (i.e. before next start)
                        If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty

                        pCount2 = pCount: ' replace current line with property/method
                        Incr LineCount
                        Incr pCount: ' Line up with where we moved definition
                        LC(pCount2).startpos = SB.len + 3
                        SB.add $CrLf + Gulp(j)
                        LC(pCount2).parentline = j
                        LC(pCount2).startline = LineCount
                        LC(pCount2).fname = pName
                        LC(pCount2).fparent = Files(i).FileName
                        LC(pCount2).date = pDate
                        LC(pCount2).type = pType
                        FirstLine2 = 0
                        If Len(tmp$) And (InStr( LCase$(tmp$), "end method" ) Or InStr( LCase$(tmp$), "end property" )) Then
                           ' Single line property or method
                           GoSub BuildLocalLibrary_EndMethodProperty
                        End If
                        Iterate For
                   End If
                   If FirstLine3 And isAlpha Then
                        'when interface, do these things.
                        ' Unterminated method/property/interface.  These are late catches (i.e. before next start)
                        If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty
                        If pCount3 Then GoSub BuildLocalLibrary_EndInterface
                        pCount3 = pCount: ' replace current line with instance
                        Incr LineCount
                        Incr pCount: ' Line up with where we moved definition
                        LC(pCount3).startpos = SB.len + 3
                        SB.add $CrLf + Gulp(j)
                        LC(pCount3).parentline = j
                        LC(pCount3).startline = LineCount
                        LC(pCount3).fname = pName
                        LC(pCount3).fparent = Files(i).FileName
                        LC(pCount3).date = pDate
                        LC(pCount3).type = pType
                        FirstLine3 = 0
                        Iterate For
                   End If

                   'when start a procedure, do these things
                   If FirstLine Then
                        If isAlpha Then
                           ' Unterminated method/property/interface/sub/macro/etc.  These are late catches (i.e. before next start)
                           If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty
                           If pCount3 Then GoSub BuildLocalLibrary_EndInterface
                           If pFlag Then GoSub BuildLocalLibrary_EndTop

                           ' The Instr ensures a valid identifier start
                           Incr LineCount
                           Incr pCount
                           pFlag = 1
                           LC(pCount).startpos = SB.len + 3
                           SB.add $CrLf + Gulp(j)
                           LC(pCount).parentline = j
                           LC(pCount).startline = LineCount
                           LC(pCount).fname = pName
                           LC(pCount).fparent = Files(i).FileName
                           LC(pCount).date = pDate
                           LC(pCount).type = pType
                           FirstLine = 0
                           ' For single line Functions/Subs (Declarations)
                           ' The following is a function definition, fairly difficult to distinguish from a regular function...
                           ' Function NewDataSet( ByRef DataSetName As String ) Common Export As iDataSet
                           LC(pCount).stopline = LineCount
                           LC(pCount).stoppos = SB.Len
                           LC(pCount).lines = LC(pCount).stopline - LC(pCount).startline + 1
                           LC(pCount).chars = LC(pCount).stoppos - LC(pCount).startpos + 1
                           If InStr( LCase$(tmp$), "end sub" ) Or InStr( LCase$(tmp$), "end function") Then
                              ' Single line sub
                              GoSub BuildLocalLibrary_EndTop
                           End If
                           If s1$="macro" And InStr(tmp$, "=")>0 Then
                               ' Single line macros end at the end of the line
                              GoSub BuildLocalLibrary_EndTop
                           End If
                        Else
                           pFlag = 0
                        End If
                        Iterate For
                  End If
                End If
             End If

             'look for ending line of Sub/Function/Class
             If pFlag Then
                  Incr LineCount
                  SB.add $CrLf + Gulp(j): ' Internal to a definition
                  If s1$ = "end" Then
                     If (s2$ = "property" Or s2$ = "method") And pCount2 Then
                         If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty
                         ' pFlag isn't 0 because this is nested
                     End If
                     If s2$ = "interface" And pCount3 Then
                        ' Unterminated method/property.  These are early catches (i.e. before next end)
                         If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty

                         If pCount3 Then GoSub BuildLocalLibrary_EndInterface
                         ' pFlag isn't 0 because this is nested
                     End If
                     If s2$ = "sub" Or s2$ = "function" Or s2$ = "class" Or s2$ = "type" Or s2$ = "enum" Or s2$ = "macro" Or s2$ = "union" Or s2$ = "fastproc" Then
                        ' Unterminated method/property/interface.  These are early catches (i.e. before next end)
                        If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty
                        If pCount3 Then GoSub BuildLocalLibrary_EndInterface

                        If pFlag Then GoSub BuildLocalLibrary_EndTop
                     End If
                  End If
             End If
         Next j
         If pCount2 Then GoSub BuildLocalLibrary_EndMethodProperty
         If pCount3 Then GoSub BuildLocalLibrary_EndInterface
         If pFlag Then GoSub BuildLocalLibrary_EndTop

         If i Mod 10 = 0 Then
             Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, Str$(i) + $Spc + Files(i).filename
             Control ReDraw hDlg, %IDC_StatusBar
         End If
    Next i

    'handle no procedures found
    If pCount = 0 Then
         pCount = 1
         sb.add $DLimit + "2014-01-01" + Exe.Path$ + $FakeFile
         sb.add "Sub No_Procedures_Found"
         sb.add "End Sub"
         BuildFakeLibrary
    End If
    'put combined code into the file
    Open LibraryFileName For Append As #1 : Print #1, SB.String : Close #1

    'give up uneeded array memory
    ReDim Preserve LC(pCount)
    ReDim Preserve Folders(FolderCount)
    ReDim Files(FileCount)
    ListView_SetItemCountEx(hListView, pCount, %LVSICF_noInvalidateAll) 'max rows
    LineCount = pCount - FileCount   'LineCount = lines of count, so take away the ++ -- ;; header lines for each file

    'correct index/create error report + build MD5 values
    Array Sort LC(1), Call SortByFNameA
    Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, " Building MD5 values ... please wait ..."

    fileBuf = ""
    For i = 1 To UBound(LC)
       temp2$ = GetSpecifiedProcedure(i)
       If UnImportant Then RemoveUnimportantCode(temp2$)
       LC(i).md5 = GetMD5(temp2$)
    Next i
    If IsFile($FakeFile) Then Kill $FakeFile

    'save index
    Open LibraryFileIndex For Binary As #1 : Put #1,, LC() : Close #1

    'display first item in list
    ListView Select hDlg, %IDC_ListView, 1
    ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
    Sci_SetText hSci, GetSpecifiedProcedure(1)
    Control ReDraw hDlg, %IDC_ListView

    QueryPerformanceCounter qStop
    MousePtr 1
    If BuildInWork = 0 Then
         MsgBox "Library Build was Cancelled!", %MB_Ok + %MB_TaskModal + %MB_IconInformation, "Cancel Build"
   Else
         BuildInWork = 0
    End If
    Dialog End hWait
    UpdateStatusbar
    Beep : Beep
      Exit Function

BuildLocalLibrary_EndMethodProperty:
   If pCount2 Then
       LC(pCount2).stopline = LineCount
       LC(pCount2).stoppos = SB.Len
       LC(pCount2).lines = LC(pCount2).stopline - LC(pCount2).startline + 1
       LC(pCount2).chars = LC(pCount2).stoppos - LC(pCount2).startpos + 1
       pCount2 = 0
   End If
   Return
BuildLocalLibrary_EndInterface:
   If pCount3 Then
      LC(pCount3).stopline = LineCount
      LC(pCount3).stoppos = SB.Len
      LC(pCount3).lines = LC(pCount3).stopline - LC(pCount3).startline + 1
      LC(pCount3).chars = LC(pCount3).stoppos - LC(pCount3).startpos + 1
      pCount3 = 0
   End If
   Return
BuildLocalLibrary_EndTop:
   If pFlag Then
      LC(pCount).stopline = LineCount
      LC(pCount).stoppos = SB.Len
      LC(pCount).lines = LC(pCount).stopline - LC(pCount).startline + 1
      LC(pCount).chars = LC(pCount).stoppos - LC(pCount).startpos + 1
      pFlag = 0
   End If
   Return
End Function

Sub OpenParentFileInLeftView(cID As Long)
    Local i As Long, temp$
    ListView Get Select hDlg, cID To i
    If i = 0 Then Exit Sub
    ListView Get Text hDlg, cID, i, 6 To temp$
    If IsFalse IsFile(temp$) Then Beep : Exit Sub
    'load the file into hSci
    Open temp$ For Binary As #1
    Get$ #1, Lof(1), temp$
    Close #1
    Sci_SetText hSci, temp$
    'scroll to procedure
    ListView Get Text hDlg, cID, i, 9 To temp$
    Sci_SetFirstVisibleLine hSci, Val(temp$)-1
End Sub

Sub SelectAllTypes(Flag As Long)
    GetSub        = Flag
    GetFunction  = Flag
    GetClass     = Flag
    GetEnum      = Flag
    GetType      = Flag
    GetCallBack  = Flag
    GetThread    = Flag
    GetDeclare   = Flag
    GetFastProc  = Flag
    GetMacro     = Flag
    GetUnion     = Flag
    GetProperty  = Flag
    GetMethod    = Flag
    GetInterface = Flag
End Sub

Sub RemoveUnimportantCode(temp$)
   Local i,iCount As Long
   'Case
   temp$ = LCase$(temp$)
   'Remove extra whitespace
   temp$ = Shrink$(temp$)
   'Remove comments
   Dim tempArray(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, tempArray(), $CrLf
   For i = 0 To UBound(tempArray)
      tempArray(i) = TrimComments(tempArray(i))
      tempArray(i) = Trim$(tempArray(i))
   Next
   'Blank lines
   For i = UBound(tempArray) To 0 Step -1
      If Len(tempArray(i)) = 0 Then
         Array Delete tempArray(i)
         Incr iCount
      End If
   Next i
   If iCount Then ReDim Preserve tempArray(UBound(tempArray)-iCount)
  'combine back into a string
   temp$ = Join$(tempArray(), $CrLf)
End Sub
